package com.bocloud.cmp.driver.agile.device;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.device.FabricPoolProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileFabricPoolModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: FabricPoolDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/6/29 17:18
 */
@Service("fabricPoolDriver")
public class FabricPoolDriver extends GenericDriver<FabricPoolProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<AgileFabricPoolModel> create(String vendor, String region, AgileFabricPoolModel model) {
        FabricPoolProvider provider = getProvider(vendor, FabricPoolProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<AgileFabricPoolModel> modify(String vendor, String region, AgileFabricPoolModel model) {
        FabricPoolProvider provider = getProvider(vendor, FabricPoolProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileFabricPoolModel> detail(String vendor, String region, String uuid) {
        FabricPoolProvider provider = getProvider(vendor, FabricPoolProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.detail(uuid);
    }

    public BocloudResult<?> remove(String vendor, String region, String uuid) {
        FabricPoolProvider provider = getProvider(vendor, FabricPoolProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.remove(uuid);
    }

}