package com.bocloud.cmp.driver.agile.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.network.DhcpGroupProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileDhcpGroupModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: DhcpGroupDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/6/29 17:09
 */
@Service("dhcpGroupDriver")
public class DhcpGroupDriver extends GenericDriver<DhcpGroupProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<AgileDhcpGroupModel> create(String vendor, String region, AgileDhcpGroupModel model) {
        DhcpGroupProvider provider = getProvider(vendor, DhcpGroupProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<AgileDhcpGroupModel> modify(String vendor, String region, AgileDhcpGroupModel model) {
        DhcpGroupProvider provider = getProvider(vendor, DhcpGroupProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileDhcpGroupModel> detail(String vendor, String region, String uuid) {
        DhcpGroupProvider provider = getProvider(vendor, DhcpGroupProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.detail(uuid);
    }

    public BocloudResult<?> remove(String vendor, String region, String uuid) {
        DhcpGroupProvider provider = getProvider(vendor, DhcpGroupProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.remove(uuid);
    }
}