package com.bocloud.cmp.driver.agile.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.network.EndPortProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileEndPortModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service("agileEndPortProvider")
public class EndPortDriver extends GenericDriver<EndPortProvider> {
    @Autowired
    private ProviderRepository repository;


    public BocloudResult<AgileEndPortModel> create(String vendor, AgileEndPortModel model) {
        EndPortProvider provider = getProvider(vendor, EndPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<?> remove(String vendor, String uuid) {
        EndPortProvider provider = getProvider(vendor, EndPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.remove(uuid);
    }

    public BocloudResult<AgileEndPortModel> modify(String vendor, AgileEndPortModel model) {
        EndPortProvider provider = getProvider(vendor, EndPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileEndPortModel> detail(String vendor, String uuid) {
        EndPortProvider provider = getProvider(vendor, EndPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.detail(uuid);
    }

}
