package com.bocloud.cmp.driver.agile.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.network.ExternalGatewayProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileExternalGatewayModel;
import com.bocloud.nms.model.agile.AgilePublicIpModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: ExternalGatewayDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/6/29 17:05
 */
@Service("externalGatewayDriver")
public class ExternalGatewayDriver extends GenericDriver<ExternalGatewayProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<AgileExternalGatewayModel> modify(String vendor, String region, AgileExternalGatewayModel model) {
        ExternalGatewayProvider provider = getProvider(vendor, ExternalGatewayProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileExternalGatewayModel> detail(String vendor, String region, String uuid) {
        ExternalGatewayProvider provider = getProvider(vendor, ExternalGatewayProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.detail(uuid);
    }

    public BocloudResult<AgilePublicIpModel> modifyPublicIpStatus(String vendor, String region, AgilePublicIpModel model) {
        ExternalGatewayProvider provider = getProvider(vendor, ExternalGatewayProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.modifyPublicIpStatus(model);
    }
}