package com.bocloud.cmp.driver.agile.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.network.ExternalNetworkProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileExternalNetworkModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: ExternalNetworkDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/6/29 17:07
 */
@Service("externalNetworkDriver")
public class ExternalNetworkDriver extends GenericDriver<ExternalNetworkProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult<AgileExternalNetworkModel> detail(String vendor, String region, String uuid) {
        ExternalNetworkProvider provider = getProvider(vendor, ExternalNetworkProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.detail(uuid);
    }

}