package com.bocloud.cmp.driver.agile.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.network.LogicSwitchPortProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileSwitchPortModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service("agileLogicPortProvider")
public class LogicPortDriver extends GenericDriver<LogicSwitchPortProvider> {

    @Autowired
    private ProviderRepository repository;


    public BocloudResult<AgileSwitchPortModel> create(String vendor, AgileSwitchPortModel model) {
        LogicSwitchPortProvider provider = getProvider(vendor, LogicSwitchPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<?> remove(String vendor, String uuid) {
        LogicSwitchPortProvider provider = getProvider(vendor, LogicSwitchPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.remove(uuid);
    }

    public BocloudResult<AgileSwitchPortModel> modify(String vendor, AgileSwitchPortModel model) {
        LogicSwitchPortProvider provider = getProvider(vendor, LogicSwitchPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileSwitchPortModel> detail(String vendor, String uuid) {
        LogicSwitchPortProvider provider = getProvider(vendor, LogicSwitchPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.detail(uuid);
    }
}
