package com.bocloud.cmp.driver.agile.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.network.LogicRouterProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileLogicRouterModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service("agileLogicRouterProvider")
public class LogicRouterDriver extends GenericDriver<LogicRouterProvider> {

    @Autowired
    private ProviderRepository repository;


    public BocloudResult<AgileLogicRouterModel> create(String vendor, AgileLogicRouterModel model) {
        LogicRouterProvider provider = getProvider(vendor, LogicRouterProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<?> remove(String vendor, String uuid) {
        LogicRouterProvider provider = getProvider(vendor, LogicRouterProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.remove(uuid);
    }

    public BocloudResult<AgileLogicRouterModel> modify(String vendor, AgileLogicRouterModel model) {
        LogicRouterProvider provider = getProvider(vendor, LogicRouterProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileLogicRouterModel> detail(String vendor, String uuid) {
        LogicRouterProvider provider = getProvider(vendor, LogicRouterProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.detail(uuid);
    }
}
