package com.bocloud.cmp.driver.agile.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.network.LogicSwitchProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileLogicSwitchModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service("agileLogicSwitchProvider")
public class LogicSwitchDriver extends GenericDriver<LogicSwitchProvider> {

    @Autowired
    private ProviderRepository repository;


    public BocloudResult<AgileLogicSwitchModel> create(String vendor, AgileLogicSwitchModel model) {
        LogicSwitchProvider provider = getProvider(vendor, LogicSwitchProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<?> remove(String vendor, String uuid) {
        LogicSwitchProvider provider = getProvider(vendor, LogicSwitchProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.remove(uuid);
    }

    public BocloudResult<AgileLogicSwitchModel> modify(String vendor, AgileLogicSwitchModel model) {
        LogicSwitchProvider provider = getProvider(vendor, LogicSwitchProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileLogicSwitchModel> detail(String vendor, String uuid) {
        LogicSwitchProvider provider = getProvider(vendor, LogicSwitchProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.detail(uuid);
    }
}
