package com.bocloud.cmp.driver.agile.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.network.SubnetProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileSubnetModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service("agileSubnetProvider")
public class SubnetDriver extends GenericDriver<SubnetProvider> {

    @Autowired
    private ProviderRepository repository;


    public BocloudResult<AgileSubnetModel> create(String vendor, AgileSubnetModel model) {
        SubnetProvider provider = getProvider(vendor, SubnetProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<?> remove(String vendor, String uuid) {
        SubnetProvider provider = getProvider(vendor, SubnetProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.remove(uuid);
    }

    public BocloudResult<AgileSubnetModel> modify(String vendor, AgileSubnetModel model) {
        SubnetProvider provider = getProvider(vendor, SubnetProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileSubnetModel> detail(String vendor, String uuid) {
        SubnetProvider provider = getProvider(vendor, SubnetProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.detail(uuid);
    }

    public BocloudResult<?> bindDhcpGroup(String vendor, String subnetUuid, String dhcpGroupUuid) {
        SubnetProvider provider = getProvider(vendor, SubnetProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.bindDhcpGroup(subnetUuid, dhcpGroupUuid);
    }

    public BocloudResult<?> unbindDhcpGroup(String vendor, String subnetUuid) {
        SubnetProvider provider = getProvider(vendor, SubnetProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.unbindDhcpGroup(subnetUuid);
    }
}
