package com.bocloud.cmp.driver.agile.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.network.VpcConnectionProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileVpcConnectionModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service("agileVpcConnectionProvider")
public class VpcConnectionDriver extends GenericDriver<VpcConnectionProvider> {

    @Autowired
    private ProviderRepository repository;


    public BocloudResult<AgileVpcConnectionModel> create(String vendor, AgileVpcConnectionModel model) {
        VpcConnectionProvider provider = getProvider(vendor, VpcConnectionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<?> remove(String vendor, String uuid) {
        VpcConnectionProvider provider = getProvider(vendor, VpcConnectionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.remove(uuid);
    }

    public BocloudResult<AgileVpcConnectionModel> modify(String vendor, AgileVpcConnectionModel model) {
        VpcConnectionProvider provider = getProvider(vendor, VpcConnectionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileVpcConnectionModel> detail(String vendor, String uuid) {
        VpcConnectionProvider provider = getProvider(vendor, VpcConnectionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.detail(uuid);
    }
}
