package com.bocloud.cmp.driver.agile.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.network.VpcProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.AgileVpcModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service("agileVpcProvider")
public class VpcDriver extends GenericDriver<VpcProvider> {

    @Autowired
    private ProviderRepository repository;


    public BocloudResult<AgileVpcModel> create(String vendor, AgileVpcModel model) {
        VpcProvider provider = getProvider(vendor, VpcProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<?> remove(String vendor, String uuid) {
        VpcProvider provider = getProvider(vendor, VpcProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.remove(uuid);
    }

    public BocloudResult<AgileVpcModel> modify(String vendor, AgileVpcModel model) {
        VpcProvider provider = getProvider(vendor, VpcProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.update(model);
    }

    public BocloudResult<AgileVpcModel> detail(String vendor, String uuid) {
        VpcProvider provider = getProvider(vendor, VpcProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.detail(uuid, null);
    }
}
