package com.bocloud.cmp.driver.agile.sfc;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.sfc.SfcContractProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.sfc.AgileSfcContractModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: SfcContractDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/6/29 16:39
 */
@Service("sfcContractDriver")
public class SfcContractDriver extends GenericDriver<SfcContractProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<AgileSfcContractModel> create(String vendor, String region, AgileSfcContractModel model) {
        SfcContractProvider provider = getProvider(vendor, SfcContractProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<AgileSfcContractModel> modify(String vendor, String region, AgileSfcContractModel model) {
        SfcContractProvider provider = getProvider(vendor, SfcContractProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileSfcContractModel> detail(String vendor, String region, String uuid) {
        SfcContractProvider provider = getProvider(vendor, SfcContractProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.detail(uuid);
    }

    public BocloudResult<?> remove(String vendor, String region, String uuid) {
        SfcContractProvider provider = getProvider(vendor, SfcContractProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.remove(uuid);
    }


}