package com.bocloud.cmp.driver.agile.sfc;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.sfc.SfcScappProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.sfc.AgileSfcScappModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: SfcScappDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/6/29 16:45
 */
@Service("sfcScappDriver")
public class SfcScappDriver extends GenericDriver<SfcScappProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult<AgileSfcScappModel> create(String vendor, String region, AgileSfcScappModel model) {
        SfcScappProvider provider = getProvider(vendor, SfcScappProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<AgileSfcScappModel> modify(String vendor, String region, AgileSfcScappModel model) {
        SfcScappProvider provider = getProvider(vendor, SfcScappProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileSfcScappModel> detail(String vendor, String region, String uuid) {
        SfcScappProvider provider = getProvider(vendor, SfcScappProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.detail(uuid);
    }

    public BocloudResult<?> remove(String vendor, String region, String uuid) {
        SfcScappProvider provider = getProvider(vendor, SfcScappProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.remove(uuid);
    }

}