package com.bocloud.cmp.driver.agile.vas;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.vas.VasProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.vas.AgileVasModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: VasDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/6/29 16:56
 */
@Service("vasDriver")
public class VasDriver extends GenericDriver<VasProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult<AgileVasModel> create(String vendor, String region, AgileVasModel model) {
        VasProvider provider = getProvider(vendor, VasProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<AgileVasModel> modify(String vendor, String region, AgileVasModel model) {
        VasProvider provider = getProvider(vendor, VasProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult<AgileVasModel> detail(String vendor, String region, String uuid) {
        VasProvider provider = getProvider(vendor, VasProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.detail(uuid);
    }

    public BocloudResult<?> remove(String vendor, String region, String uuid) {
        VasProvider provider = getProvider(vendor, VasProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.remove(uuid);
    }


}