package com.bocloud.cmp.driver.agile.vas;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.agile.vas.VasLinkProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.agile.vas.AgileVasLinkModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: VasLinkDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/6/29 16:54
 */
@Service("vasLinkDriver")
public class VasLinkDriver extends GenericDriver<VasLinkProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult<AgileVasLinkModel> create(String vendor, String region, AgileVasLinkModel model) {
        VasLinkProvider provider = getProvider(vendor, VasLinkProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<?> remove(String vendor, String region, AgileVasLinkModel model) {
        VasLinkProvider provider = getProvider(vendor, VasLinkProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.remove(model);
    }
}