package com.bocloud.cmp.driver.azure.automation;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.automation.LogAnalyticModel;
import com.bocloud.cmp.provider.azure.automation.LogAnalyticProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: LogAnalyticDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/8/11 14:51
 */
@Service("logAnalyticDriver")
public class LogAnalyticDriver extends GenericDriver<LogAnalyticProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        LogAnalyticProvider provider = getProvider(vendor, LogAnalyticProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult detail(String vendor, LogAnalyticModel model) {
        LogAnalyticProvider provider = getProvider(vendor, LogAnalyticProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(model);
    }

    public BocloudResult remove(String vendor, LogAnalyticModel model) {
        LogAnalyticProvider provider = getProvider(vendor, LogAnalyticProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(model);
    }

    public BocloudResult sharedKeys(String vendor, LogAnalyticModel model) {
        LogAnalyticProvider provider = getProvider(vendor, LogAnalyticProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.sharedKeys(model);
    }

    public BocloudResult create(String vendor, String region, LogAnalyticModel model) {
        LogAnalyticProvider provider = getProvider(vendor, LogAnalyticProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult linkedServices(String vendor, LogAnalyticModel model) {
        LogAnalyticProvider provider = getProvider(vendor, LogAnalyticProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.linkedServices(model);
    }

    public BocloudResult queryLogAnalytic(String vendor, LogAnalyticModel model, String operation, String resourceId) {
        LogAnalyticProvider provider = getProvider(vendor, LogAnalyticProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.queryLogAnalytic(model, operation,resourceId);
    }


}