package com.bocloud.cmp.driver.azure.checkname;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.azure.checkname.ResourceCheckNameProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: ResourceCheckNameDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/3/10 11:16
 */
@Service
public class ResourceCheckNameDriver extends GenericDriver<ResourceCheckNameProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult checkName(String vendor, String name, String type) {
        ResourceCheckNameProvider provider = getProvider(vendor, ResourceCheckNameProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.checkName(name, type);
    }
}