package com.bocloud.cmp.driver.azure.db;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.db.AzureDatabaseServerModel;
import com.bocloud.cmp.provider.azure.db.CloudDatabaseServerProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: DatabaseForMysqlDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/12/18 15:21
 */
@Service("cloudDatabaseServerDriver")
public class CloudDatabaseServerDriver extends GenericDriver<CloudDatabaseServerProvider> {

    @Autowired
    private ProviderRepository repository;


    public BocloudResult detail(String vendor, String region, AzureDatabaseServerModel model) {
        CloudDatabaseServerProvider provider = getProvider(vendor, CloudDatabaseServerProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(model);
    }

    public BocloudResult create(String vendor, String region, AzureDatabaseServerModel model) {
        CloudDatabaseServerProvider provider = getProvider(vendor, CloudDatabaseServerProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String vendor, String region, AzureDatabaseServerModel model) {
        CloudDatabaseServerProvider provider = getProvider(vendor, CloudDatabaseServerProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(model);
    }

    public BocloudResult restart(String vendor, String region, AzureDatabaseServerModel model) {
        CloudDatabaseServerProvider provider = getProvider(vendor, CloudDatabaseServerProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.restart(model);
    }

    public BocloudResult modify(String vendor, String region, AzureDatabaseServerModel model) {
        CloudDatabaseServerProvider provider = getProvider(vendor, CloudDatabaseServerProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult pricingLayer(String vendor, String region, AzureDatabaseServerModel model) {
        CloudDatabaseServerProvider provider = getProvider(vendor, CloudDatabaseServerProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.pricingLayer(model);
    }

}