package com.bocloud.cmp.driver.azure.db;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.db.AzureDatabaseServerModel;
import com.bocloud.cmp.model.azure.db.DbConfigurationModel;
import com.bocloud.cmp.provider.azure.db.configuration.DbConfigurationProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: CloudDatabaseServerConfigurationDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/2/4 18:00
 */
@Service("dbConfigurationDriver")
public class DbConfigurationDriver extends GenericDriver<DbConfigurationProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor, String region, AzureDatabaseServerModel model) {
        DbConfigurationProvider provider = getProvider(vendor, DbConfigurationProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list(model);
    }

    public BocloudResult detail(String vendor, String region, DbConfigurationModel model) {
        DbConfigurationProvider provider = getProvider(vendor, DbConfigurationProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(model);
    }

    public BocloudResult createOrUpdate(String vendor, String region, DbConfigurationModel model) {
        DbConfigurationProvider provider = getProvider(vendor, DbConfigurationProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

}