package com.bocloud.cmp.driver.azure.db;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.db.DbFirewallRuleModel;
import com.bocloud.cmp.provider.azure.db.firewall.DbFirewallRuleProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: DbFirewallRuleDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/2/1 14:26
 */
@Service("dbFirewallRuleDriver")
public class DbFirewallRuleDriver extends GenericDriver<DbFirewallRuleProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult detail(String vendor, String region, DbFirewallRuleModel model) {
        DbFirewallRuleProvider provider = getProvider(vendor, DbFirewallRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(model);
    }

    public BocloudResult create(String vendor, String region, DbFirewallRuleModel model) {
        DbFirewallRuleProvider provider = getProvider(vendor, DbFirewallRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String vendor, String region, DbFirewallRuleModel model) {
        DbFirewallRuleProvider provider = getProvider(vendor, DbFirewallRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(model);
    }

}