package com.bocloud.cmp.driver.azure.ddos;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.ddos.DdosCustomPolicieModel;
import com.bocloud.cmp.provider.azure.ddos.DdosCustomPolicieProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author wangyu
 * @version 5.0.0-SNAPSHOT
 * @since 2021/3/1
 */
@Service
public class DdosCustomPolicieDriver extends GenericDriver<DdosCustomPolicieProvider> {

    @Autowired
    private ProviderRepository repository;

//    public BocloudResult list(String resourceGroup, String vendor) {
//        DdosCustomPolicieProvider provider = getProvider(vendor, DdosCustomPolicieProvider.class, repository);
//        if (before(provider).isFailed()) {
//            return BocloudResult.FAILED("平台认证失败！");
//        }
//        return provider.list(resourceGroup);
//    }

    public BocloudResult create(DdosCustomPolicieModel model, String vendor) {
        DdosCustomPolicieProvider provider = getProvider(vendor, DdosCustomPolicieProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(DdosCustomPolicieModel model, String vendor) {
        DdosCustomPolicieProvider provider = getProvider(vendor, DdosCustomPolicieProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult delete(DdosCustomPolicieModel model, String vendor) {
        DdosCustomPolicieProvider provider = getProvider(vendor, DdosCustomPolicieProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(model);
    }
}
