package com.bocloud.cmp.driver.azure.ddos;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.ddos.DdosProtectionPlanModel;
import com.bocloud.cmp.provider.azure.ddos.DdosProtectionPlanProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author wangyu
 * @version 5.0.0-SNAPSHOT
 * @since 2021/3/1
 */
@Service
public class DdosProtectionPlanDriver extends GenericDriver<DdosProtectionPlanProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String resourceGroup, String vendor) {
        DdosProtectionPlanProvider provider = getProvider(vendor, DdosProtectionPlanProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list(resourceGroup);
    }

    public BocloudResult create(DdosProtectionPlanModel model, String vendor) {
        DdosProtectionPlanProvider provider = getProvider(vendor, DdosProtectionPlanProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(DdosProtectionPlanModel model, String vendor) {
        DdosProtectionPlanProvider provider = getProvider(vendor, DdosProtectionPlanProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult delete(String planId, String vendor) {
        DdosProtectionPlanProvider provider = getProvider(vendor, DdosProtectionPlanProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.delete(planId);
    }
}
