package com.bocloud.cmp.driver.azure.redis;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.redis.RedisModel;
import com.bocloud.cmp.provider.azure.redis.RedisProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: RedisDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/3/1 14:18
 */
@Service
public class RedisDriver extends GenericDriver<RedisProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult detail(String vendor, String region, RedisModel model) {
        RedisProvider provider = getProvider(vendor, RedisProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(model);
    }

    public BocloudResult create(String vendor, String region, RedisModel model) {
        RedisProvider provider = getProvider(vendor, RedisProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String vendor, String region, RedisModel model) {
        RedisProvider provider = getProvider(vendor, RedisProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(model);
    }

    public BocloudResult restart(String vendor, String region, RedisModel model) {
        RedisProvider provider = getProvider(vendor, RedisProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.restart(model);
    }

    public BocloudResult modify(String vendor, String region, RedisModel model) {
        RedisProvider provider = getProvider(vendor, RedisProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult regenerateKey(String vendor, String region, RedisModel model) {
        RedisProvider provider = getProvider(vendor, RedisProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.regenerateKey(model);
    }

    public BocloudResult pricingLayer(String vendor, String region, RedisModel model) {
        RedisProvider provider = getProvider(vendor, RedisProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.pricingLayer(model);
    }

}