package com.bocloud.cmp.driver.azure.redis;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.redis.RedisFirewallRuleModel;
import com.bocloud.cmp.provider.azure.redis.firewall.RedisFirewallRuleProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: RedisFirewallRuleDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/3/1 14:20
 */
@Service
public class RedisFirewallRuleDriver extends GenericDriver<RedisFirewallRuleProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult detail(String vendor, String region, RedisFirewallRuleModel model) {
        RedisFirewallRuleProvider provider = getProvider(vendor, RedisFirewallRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(model);
    }

    public BocloudResult create(String vendor, String region, RedisFirewallRuleModel model) {
        RedisFirewallRuleProvider provider = getProvider(vendor, RedisFirewallRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String vendor, String region, RedisFirewallRuleModel model) {
        RedisFirewallRuleProvider provider = getProvider(vendor, RedisFirewallRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(model);
    }
}