package com.bocloud.cmp.driver.azure.slb;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.slb.BackEndModel;
import com.bocloud.cmp.provider.azure.slb.BackEndProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName: BackEndDriver
 * @Description:
 * @author: zhenpingLi/李振平
 */
@Service("backEndDriver")
public class BackEndDriver extends GenericDriver<BackEndProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, String region, BackEndModel model) {
        BackEndProvider provider = getProvider(vendor, BackEndProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String vendor, String region, BackEndModel model) {
        BackEndProvider provider = getProvider(vendor, BackEndProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(model);
    }

    public BocloudResult modify(String vendor, String region, BackEndModel model) {
        BackEndProvider provider = getProvider(vendor, BackEndProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(model);
    }


}