package com.bocloud.cmp.driver.azure.slb;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.slb.FrontEndModel;
import com.bocloud.cmp.provider.azure.slb.FrontEndProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName: FrontEndDriver
 * @Description:
 * @author: zhenpingLi/李振平
 */
@Service("frontEndDriver")
public class FrontEndDriver extends GenericDriver<FrontEndProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, String region, FrontEndModel model) {
        FrontEndProvider provider = getProvider(vendor, FrontEndProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String vendor, String region, FrontEndModel model) {
        FrontEndProvider provider = getProvider(vendor, FrontEndProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(model);
    }
}