package com.bocloud.cmp.driver.azure.slb;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.slb.InboundNatRuleModel;
import com.bocloud.cmp.provider.azure.slb.InboundNatRuleProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName: InboundNatRuleDriver
 * @Description:
 * @author: zhenpingLi/李振平
 */
@Service("inboundNatRuleDriver")
public class InboundNatRuleDriver extends GenericDriver<InboundNatRuleProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, String region, InboundNatRuleModel model) {
        InboundNatRuleProvider provider = getProvider(vendor, InboundNatRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String vendor, String region, InboundNatRuleModel model) {
        InboundNatRuleProvider provider = getProvider(vendor, InboundNatRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(model);
    }
}