package com.bocloud.cmp.driver.azure.slb;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.slb.SlbModel;
import com.bocloud.cmp.provider.azure.slb.LoadBalanceProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName: LoadBalanceDriver
 * @Description:
 * @author: zhenpingLi/李振平
 */
@Service("loadBalanceDriver")
public class LoadBalanceDriver extends GenericDriver<LoadBalanceProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, String region, SlbModel model) {
        LoadBalanceProvider provider = getProvider(vendor, LoadBalanceProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String vendor, String region, String uuid) {
        LoadBalanceProvider provider = getProvider(vendor, LoadBalanceProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(uuid);
    }

}