package com.bocloud.cmp.driver.azure.slb;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.slb.LoadBalanceRuleModel;
import com.bocloud.cmp.provider.azure.slb.LoadBalanceRuleProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName: LoadBalanceRuleDriver
 * @Description:
 * @author: zhenpingLi/李振平
 */
@Service("loadBalanceRuleDriver")
public class LoadBalanceRuleDriver extends GenericDriver<LoadBalanceRuleProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, String region, LoadBalanceRuleModel model) {
        LoadBalanceRuleProvider provider = getProvider(vendor, LoadBalanceRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(String vendor, String region, LoadBalanceRuleModel model) {
        LoadBalanceRuleProvider provider = getProvider(vendor, LoadBalanceRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult remove(String vendor, String region, LoadBalanceRuleModel model) {
        LoadBalanceRuleProvider provider = getProvider(vendor, LoadBalanceRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(model);
    }
}