package com.bocloud.cmp.driver.azure.slb;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.slb.SlbModel;
import com.bocloud.cmp.provider.azure.slb.OutboundRuleProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: OutboundRuleDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/5/15 16:34
 */
@Service
public class OutboundRuleDriver extends GenericDriver<OutboundRuleProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor, String region, SlbModel model) {
        OutboundRuleProvider provider = getProvider(vendor, OutboundRuleProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.list(model);
    }

}