package com.bocloud.cmp.driver.azure.slb;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.slb.ProbeModel;
import com.bocloud.cmp.provider.azure.slb.ProbeProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName: ProbeDriver
 * @Description:
 * @author: zhenpingLi/李振平
 */
@Service("probeDriver")
public class ProbeDriver extends GenericDriver<ProbeProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, String region, ProbeModel model) {
        ProbeProvider provider = getProvider(vendor, ProbeProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(String vendor, String region, ProbeModel model) {
        ProbeProvider provider = getProvider(vendor, ProbeProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult remove(String vendor, String region, ProbeModel model) {
        ProbeProvider provider = getProvider(vendor, ProbeProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(model);
    }
}