package com.bocloud.cmp.driver.azure.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.azure.storage.DiskEncryptionProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: DiskEncryptionDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/4/21 15:58
 */
@Service("diskEncryptionDriver")
public class DiskEncryptionDriver extends GenericDriver<DiskEncryptionProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        DiskEncryptionProvider provider = getProvider(vendor, DiskEncryptionProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list();
    }


}