package com.bocloud.cmp.driver.azure.tags;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.tags.TagModel;
import com.bocloud.cmp.provider.azure.tags.TagProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: TagDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/6/8 9:46
 */
@Service("azureTagDriver")
public class TagDriver extends GenericDriver<TagProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult tags(String vendor, String region, TagModel model) {
        TagProvider provider = getProvider(vendor, TagProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.tags(model);
    }
}