package com.bocloud.cmp.driver.backup;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.BackupModel;
import com.bocloud.cmp.model.BackupPolicyModel;
import com.bocloud.cmp.provider.backup.BackupProvider;
import com.bocloud.common.model.BocloudResult;

@Service("backupDriver")
public class BackupDriver extends GenericDriver<BackupProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult create(BackupModel model, String vendor, String regionId) {
		BackupProvider provider = getProvider(vendor, BackupProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult list(BackupModel model, String vendor, String regionId) {
		BackupProvider provider = getProvider(vendor, BackupProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list(model);
	}

	public BocloudResult remove(BackupModel model, String vendor, String regionId) {
		BackupProvider provider = getProvider(vendor, BackupProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult restore(BackupModel model, String vendor, String regionId) {
		BackupProvider provider = getProvider(vendor, BackupProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.restore(model);
	}

	public BocloudResult modify(BackupModel model, String vendor, String regionId) {
		BackupProvider provider = getProvider(vendor, BackupProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult listBackupPolicy(BackupPolicyModel policyModel, String vendor, String regionId) {
		BackupProvider provider = getProvider(vendor, BackupProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.listBackupPolicy(policyModel);
	}

}
