package com.bocloud.cmp.driver.backup;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.VaultsModel;
import com.bocloud.cmp.provider.backup.VaultsProvider;
import com.bocloud.common.model.BocloudResult;

@Service("vaultsDriver")
public class VaultsDriver extends GenericDriver<VaultsProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(VaultsModel model, String vendor, String regionId) {
		VaultsProvider provider = getProvider(vendor, VaultsProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list(model);
	}

	public BocloudResult addResources(VaultsModel model, String vendor, String regionId) {
		VaultsProvider provider = getProvider(vendor, VaultsProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.addResources(model);
	}

	public BocloudResult removeResources(VaultsModel model, String vendor, String regionId) {
		VaultsProvider provider = getProvider(vendor, VaultsProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.removeResources(model);
	}

	public BocloudResult create(VaultsModel model, String vendor, String regionId) {
		VaultsProvider provider = getProvider(vendor, VaultsProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(VaultsModel model, String vendor, String regionId) {
		VaultsProvider provider = getProvider(vendor, VaultsProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult modify(VaultsModel model, String vendor, String regionId) {
		VaultsProvider provider = getProvider(vendor, VaultsProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult detail(VaultsModel model, String vendor, String regionId) {
		VaultsProvider provider = getProvider(vendor, VaultsProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.detail(model);
	}

	public BocloudResult checkpoints(VaultsModel model, String vendor, String regionId) {
		VaultsProvider provider = getProvider(vendor, VaultsProvider.class, repository, regionId);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.checkpoints(model);
	}

}
