package com.bocloud.cmp.driver.campus;


import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.campus.AssignedIpScopeProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.campus.AssignedIpInfoModel;
import com.bocloud.nms.model.campus.AssignedIpScopeModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/2/26 10:50 上午
 */
@Service("assignedIpScopeDriver")
public class AssignedIpScopeDriver extends GenericDriver<AssignedIpScopeProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<List<AssignedIpScopeModel>> list(String vendor) {
        AssignedIpScopeProvider provider = getProvider(vendor, AssignedIpScopeProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult<AssignedIpScopeModel> create(String vendor, AssignedIpScopeModel model) {
        AssignedIpScopeProvider provider = getProvider(vendor, AssignedIpScopeProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<AssignedIpScopeModel> createChild(String vendor, Long parentId, AssignedIpScopeModel model) {
        AssignedIpScopeProvider provider = getProvider(vendor, AssignedIpScopeProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.createChild(parentId, model);
    }

    public BocloudResult<?> update(String vendor, AssignedIpScopeModel model) {
        AssignedIpScopeProvider provider = getProvider(vendor, AssignedIpScopeProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.update(model);
    }

    public BocloudResult<?> freed(String vendor, Long id) {
        AssignedIpScopeProvider provider = getProvider(vendor, AssignedIpScopeProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.freed(id);
    }

    public BocloudResult<?> freedUsed(String vendor, Long id) {
        AssignedIpScopeProvider provider = getProvider(vendor, AssignedIpScopeProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.freedUsed(id);
    }

    public BocloudResult<?> assignIp(String vendor, AssignedIpInfoModel model) {
        AssignedIpScopeProvider provider = getProvider(vendor, AssignedIpScopeProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.assignIp(model);
    }

    public BocloudResult<?> get(String vendor, Long id) {
        AssignedIpScopeProvider provider = getProvider(vendor, AssignedIpScopeProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.get(id);
    }
}
