package com.bocloud.cmp.driver.campus;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.campus.DeviceProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.campus.DeviceModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("campusDeviceDriver")
public class DeviceDriver extends GenericDriver<DeviceProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<List<DeviceModel>> list(String vendor) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult<DeviceModel> create(String vendor, DeviceModel model) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult<?> remove(String vendor, Long deviceUuid) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.remove(deviceUuid);
    }

    public BocloudResult<?> ping(String vendor, Long deviceId) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.ping(deviceId);
    }

    public BocloudResult<?> tracert(String vendor, Long deviceId) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.ping(deviceId);
    }



}
