package com.bocloud.cmp.driver.campus;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.campus.DeviceInterfaceProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.campus.DeviceInterfaceModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("campusDeviceInterfaceDriver")
public class DeviceInterfaceDriver extends GenericDriver<DeviceInterfaceProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<List<DeviceInterfaceModel>> list(String vendor, Long deviceId) {
        DeviceInterfaceProvider provider = getProvider(vendor, DeviceInterfaceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.list(deviceId);
    }

    public BocloudResult<?> up(String vendor, Long deviceId, Long portId) {
        DeviceInterfaceProvider provider = getProvider(vendor, DeviceInterfaceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.up(deviceId, portId);
    }

    public BocloudResult<?> down(String vendor, Long deviceId, Long portId) {
        DeviceInterfaceProvider provider = getProvider(vendor, DeviceInterfaceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.down(deviceId, portId);
    }


}
