package com.bocloud.cmp.driver.campus;


import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.campus.DomainProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.campus.DomainModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/2/26 10:50 上午
 */
@Service("domainDriver")
public class DomainDriver extends GenericDriver<DomainProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<DomainModel> get(String vendor, Long domainId) {
        DomainProvider provider = getProvider(vendor, DomainProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.get(domainId);
    }
}
