package com.bocloud.cmp.driver.campus;


import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.campus.SecGroupProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.campus.SecGroupModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/2/26 10:50 上午
 */
@Service("secGroupDriver")
public class SecGroupDriver extends GenericDriver<SecGroupProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<List<SecGroupModel>> list(String vendor) {
        SecGroupProvider provider = getProvider(vendor, SecGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.list();
    }
}
