package com.bocloud.cmp.driver.common;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.common.CostProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 成本
 *
 * @author
 */
@Service("costDriver")
public class CostDriver extends GenericDriver<CostProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String granularity, String metrics, String start, String end, String vendor) {
        CostProvider provider = getProvider(vendor, CostProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.listByResource(granularity, metrics, start, end);
    }
}
