package com.bocloud.cmp.driver.common;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.EnterpriseProjectModel;
import com.bocloud.cmp.provider.common.EnterpriseProvider;
import com.bocloud.common.model.BocloudResult;

@Service("enterpriseDriver")
public class EnterpriseDriver extends GenericDriver<EnterpriseProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult listEnterpriseProject(String vendor, String region) {
		EnterpriseProvider provider = getProvider(vendor, EnterpriseProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.listEnterpriseProject();
	}

	public BocloudResult modifyEnterpriseProject(String vendor, EnterpriseProjectModel model, String region) {
		EnterpriseProvider provider = getProvider(vendor, EnterpriseProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.modifyEnterpriseProject(model);
	}

	public BocloudResult createEnterpriseProject(String vendor, EnterpriseProjectModel model, String region) {
		EnterpriseProvider provider = getProvider(vendor, EnterpriseProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.createEnterpriseProject(model);
	}

	public BocloudResult enterpriseProjectEnable(String vendor, EnterpriseProjectModel model, String region) {
		EnterpriseProvider provider = getProvider(vendor, EnterpriseProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.enterpriseProjectEnable(model);
	}
}
