package com.bocloud.cmp.driver.common;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.HeatStackModel;
import com.bocloud.cmp.provider.common.HeatProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * op heat service
 * 
 * @author ymh
 * @时间 2019年11月13日
 */
@Service("heatDriver")
public class HeatDriver extends GenericDriver<HeatProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult createStack(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.createStack(heatStackModel);
    }

    public BocloudResult createStack(HeatStackModel heatStackModel, String projectName, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, projectName, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.createStack(heatStackModel);
    }

    public BocloudResult listStack(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.listStack(heatStackModel);
    }

    public BocloudResult detailStack(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.detailStack(heatStackModel);
    }

    public BocloudResult modifyStack(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.modifyStack(heatStackModel);
    }

    public BocloudResult modifyStack(HeatStackModel heatStackModel, String projectName, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, projectName, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.modifyStack(heatStackModel);
    }

    public BocloudResult removeStack(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.removeStack(heatStackModel);
    }

    public BocloudResult removeStack(HeatStackModel heatStackModel, String projectName, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, projectName, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.removeStack(heatStackModel);
    }

    public BocloudResult exportStack(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.exportStack(heatStackModel);
    }

    public BocloudResult detailStackTemplate(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.detailStackTemplate(heatStackModel);
    }

    public BocloudResult detailStackEnvironment(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.detailStackEnvironment(heatStackModel);
    }

    public BocloudResult stackFiles(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.stackFiles(heatStackModel);
    }

    public BocloudResult templateVersions(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.templateVersions(heatStackModel);
    }

    public BocloudResult suspendStack(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.suspendStack(heatStackModel);
    }

    public BocloudResult resumeStack(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.resumeStack(heatStackModel);
    }

    public BocloudResult cheakStack(HeatStackModel heatStackModel, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.cheakStack(heatStackModel);
    }

    public BocloudResult detailStack(HeatStackModel heatStackModel, String projectName, String vendor, String region) {
        HeatProvider provider = getProvider(vendor, projectName, HeatProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.detailStack(heatStackModel);
    }

}
