package com.bocloud.cmp.driver.common;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.common.RegionProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: RegionDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/2/5 10:35
 */
@Service("regionDriver")
public class RegionDriver extends GenericDriver<RegionProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        RegionProvider provider = getProvider(vendor, RegionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.list();
    }

}