package com.bocloud.cmp.driver.common;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.TaskMsgModel;
import com.bocloud.cmp.provider.common.TaskMsgProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 任务消息服务接口实现类
 *
 * @author wangyu
 * @version 4.1.0-SNAPSHOT
 * @since 2018/11/20
 */
@Component
public class TaskMsgDriver extends GenericDriver<TaskMsgProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        TaskMsgProvider provider = getProvider(vendor, TaskMsgProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.list();
    }


    public BocloudResult get(Long msgId, String vendor) {
        TaskMsgProvider provider = getProvider(vendor, TaskMsgProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.get(msgId);
    }

    public BocloudResult<List<TaskMsgModel>> historyList(String vendor) {
        TaskMsgProvider provider = getProvider(vendor, TaskMsgProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.historyList();
    }

    public BocloudResult<TaskMsgModel> get(String uuid, String vendor) {
        TaskMsgProvider provider = getProvider(vendor, TaskMsgProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "云平台认证失败！");
        }
        return provider.get(uuid);
    }
}
