package com.bocloud.cmp.driver.common;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.common.ValidateProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 验证环境服务实现类
 *
 * @author lkx007
 */
@Service("validateDriver")
public class ValidateDriver extends GenericDriver<ValidateProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult validate(String vendor) {
        ValidateProvider provider = getProvider(vendor, ValidateProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.validate();
    }

    public BocloudResult result(String vendor) {
        ValidateProvider provider = getProvider(vendor, ValidateProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.result();
    }
}
