package com.bocloud.cmp.driver.common;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.common.VdcProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * 数据中心操作服务接口实现类
 * 
 * @author weiwei
 *
 */
@Service("vdcDriver")
public class VdcDriver extends GenericDriver<VdcProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		VdcProvider provider = getProvider(vendor, VdcProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list();
	}
}
