package com.bocloud.cmp.driver.common;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.common.ZoneProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 可用区
 *
 * @author lyy
 * @version 1.0
 * @date 2021/1/7 16:15
 */
@Service("zoneDriver")
public class ZoneDriver extends GenericDriver<ZoneProvider> {
	@Autowired
	private ProviderRepository repository;

	public BocloudResult queryByRegionId(String vendor, String type, String region) {
		ZoneProvider provider = getProvider(vendor, ZoneProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.query(type);
	}
}
