package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.AvailabilitySetModel;
import com.bocloud.cmp.provider.compute.AvailabilitySetProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName: AvailabilitySetDriver
 * @Description:
 * @author: zhenpingLi/李振平
 */
@Service("availabilitySetDriver")
public class AvailabilitySetDriver extends GenericDriver<AvailabilitySetProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, String region, AvailabilitySetModel model) {
        AvailabilitySetProvider provider = getProvider(vendor, AvailabilitySetProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String vendor, String region, String uuid) {
        AvailabilitySetProvider provider = getProvider(vendor, AvailabilitySetProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(uuid);
    }
}