package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.VDCModel;
import com.bocloud.cmp.provider.compute.HostPoolProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 主机池provider
 *
 * @author hufy
 */
@Service("hostPoolDriver")
public class HostPoolDriver extends GenericDriver<HostPoolProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, VDCModel vdcModel) {
        HostPoolProvider poolProvider = getProvider(vendor, HostPoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return poolProvider.create(vdcModel.getName());
        }
    }


    public BocloudResult remove(String vendor, String vdcVal) {
        HostPoolProvider poolProvider = getProvider(vendor, HostPoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return poolProvider.remove(vdcVal);
        }
    }


    public BocloudResult detail(String vendor, String name) {
        HostPoolProvider poolProvider = getProvider(vendor, HostPoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return poolProvider.detail(name);
        }
    }

    public BocloudResult summary(String vendor, String vdcVal) {
        HostPoolProvider poolProvider = getProvider(vendor, HostPoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return poolProvider.summary(vdcVal);
        }
    }

    public BocloudResult listHostAndCluster(String vendor, Long hpId) {
        HostPoolProvider poolProvider = getProvider(vendor, HostPoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return poolProvider.listHostAndCluster(hpId);
        }
    }

    public BocloudResult create(String vendor, String name) {
        HostPoolProvider poolProvider = getProvider(vendor, HostPoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return poolProvider.create(name);
        }
    }

    public BocloudResult list(String vendor) {
        HostPoolProvider poolProvider = getProvider(vendor, HostPoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return poolProvider.list();
        }
    }

}
