package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.powervc.HostSeaAdapterModel;
import com.bocloud.cmp.provider.compute.HostSeaProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 主机 sea provider
 *
 * @author lkx007
 */
@Service("hostSeaDriver")
public class HostSeaDriver extends GenericDriver<HostSeaProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        HostSeaProvider provider = getProvider(vendor, HostSeaProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return provider.list();
        }
    }

    public BocloudResult list(String vendor, long vlanId) {
        HostSeaProvider provider = getProvider(vendor, HostSeaProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return provider.list(vlanId);
        }
    }

    public BocloudResult list(String vendor, String networkUuid, long vlanId) {
        HostSeaProvider provider = getProvider(vendor, HostSeaProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return provider.list(networkUuid, vlanId);
        }
    }

    public BocloudResult createMapping(String vendor, List<HostSeaAdapterModel> seas) {
        HostSeaProvider provider = getProvider(vendor, HostSeaProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "用户鉴权失败！");
        } else {
            return provider.createMapping(seas);
        }
    }
}
