package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.compute.HostProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("hyperVDriver")
public class HyperVDriver extends GenericDriver<HostProvider> {
    @Autowired
    private ProviderRepository repository;


    public BocloudResult list(String vendor, String region) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.list();
    }


    public BocloudResult listPerf(String vendor) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.monitor();
    }

}
