package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.compute.MessageProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

/**
 * 云平台控制台消息接口实现类
 *
 * @author lkx007
 */
@Repository("messageDriver")
public class MessageDriver extends GenericDriver<MessageProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        MessageProvider messageProvider = getProvider(vendor, MessageProvider.class, repository);
        if (before(messageProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return messageProvider.list();
    }

    public BocloudResult delete(String vendor, Integer messageId) {
        MessageProvider messageProvider = getProvider(vendor, MessageProvider.class, repository);
        if (before(messageProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return messageProvider.delete(messageId);
    }

    public BocloudResult deleteAll(String vendor) {
        MessageProvider messageProvider = getProvider(vendor, MessageProvider.class, repository);
        if (before(messageProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return messageProvider.deleteAll();
    }
}