package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.PoolModel;
import com.bocloud.cmp.provider.compute.PoolProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * pool服务接口实现类
 *
 * @author weiwei
 */
@Service("poolDriver")
public class PoolDriver extends GenericDriver<PoolProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult remove(String vendor, String name, String target) {
        PoolProvider poolProvider = getProvider(vendor, PoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "平台认证失败!");
        }
        return poolProvider.remove(name, target);
    }

    public BocloudResult create(String vendor, String target, PoolModel model) {
        PoolProvider poolProvider = getProvider(vendor, PoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "平台认证失败!");
        }
        return poolProvider.create(model, target);
    }

    public BocloudResult modify(String vendor, String name, String var, Integer value, String target) {
        PoolProvider poolProvider = getProvider(vendor, PoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "平台认证失败!");
        }
        return poolProvider.modify(name, var, value, target);
    }

    public BocloudResult detail(String vendor, String name, String target) {
        PoolProvider poolProvider = getProvider(vendor, PoolProvider.class, repository);
        if (before(poolProvider).isFailed()) {
            return new BocloudResult(false, "平台认证失败!");
        }
        return poolProvider.detail(name, target);
    }

}
