package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.ResourcePoolBean;
import com.bocloud.cmp.model.ResourcePoolModel;
import com.bocloud.cmp.provider.compute.ResourcePoolProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 资源池操作实现
 *
 * @author wangyu
 * @version 1.0
 * @since 2017年11月24日
 */
@Service("resourcePoolDriver")
public class ResourcePoolDriver extends GenericDriver<ResourcePoolProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, ResourcePoolModel model) {
        ResourcePoolProvider provider = getProvider(vendor, ResourcePoolProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }


    public BocloudResult modify(String vendor, ResourcePoolBean bean) {
        ResourcePoolProvider provider = getProvider(vendor, ResourcePoolProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(bean);
    }


    public BocloudResult remove(String vendor, String poolName) {
        ResourcePoolProvider provider = getProvider(vendor, ResourcePoolProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(poolName);
    }


    public BocloudResult list(String vendor, String vdcName) {
        ResourcePoolProvider provider = getProvider(vendor, ResourcePoolProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.list(vdcName);
    }
}
