package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.sangfor.SangforGroupModel;
import com.bocloud.cmp.provider.compute.GroupServerProvider;
import com.bocloud.cmp.provider.compute.ServerProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("sangforGroupServerDriver")
public class SangforGroupServerDriver extends GenericDriver<GroupServerProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, SangforGroupModel groupModel) {

        GroupServerProvider provider = getProvider(vendor, GroupServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return provider.create(groupModel);
    }

    public BocloudResult update(String vendor, SangforGroupModel groupModel) {
        GroupServerProvider provider = getProvider(vendor, GroupServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return provider.update(groupModel);
    }

    public BocloudResult delete(String vendor, String groupId) {
        GroupServerProvider provider = getProvider(vendor, GroupServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return provider.delete(groupId);
    }
}
