package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.SnapshotBackupModel;
import com.bocloud.cmp.provider.compute.SnapshotBackupProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 快照操作服务接口实现类
 *
 * @author weiwei
 */
@Service("snapshotBackupDriver")
public class SnapshotBackupDriver extends GenericDriver<SnapshotBackupProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, String region, SnapshotBackupModel model) {
        SnapshotBackupProvider provider = getProvider(vendor, SnapshotBackupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult list(String vendor, String region) {
        SnapshotBackupProvider provider = getProvider(vendor, SnapshotBackupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult detail(String vendor, String region, SnapshotBackupModel model) {
        SnapshotBackupProvider provider = getProvider(vendor, SnapshotBackupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.detail(model);
    }

    public BocloudResult remove(String vendor, String region, SnapshotBackupModel model) {
        SnapshotBackupProvider provider = getProvider(vendor, SnapshotBackupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(model);
    }

    public BocloudResult restore(SnapshotBackupModel model, String vendor, String region) {
        SnapshotBackupProvider provider = getProvider(vendor, SnapshotBackupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.restore(model);
    }
}
