package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.compute.StorageConnGroupProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 存储器链接组
 */
@Service("storageConnGroupDriver")
public class StorageConnGroupDriver extends GenericDriver<StorageConnGroupProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        StorageConnGroupProvider storageConnGroupProvider = getProvider(vendor, StorageConnGroupProvider.class, repository);
        if (before(storageConnGroupProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return storageConnGroupProvider.list();
    }

}
