package com.bocloud.cmp.driver.compute;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.VAppModel;
import com.bocloud.cmp.provider.common.VAppProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 资源池操作实现
 *
 * @author wangyu
 * @version 1.0
 * @since 2017年11月24日
 */
@Service("vAppDriver")
public class VAppDriver extends GenericDriver<VAppProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, VAppModel model) {
        VAppProvider provider = getProvider(vendor, VAppProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(String vendor, VAppModel model) {
        VAppProvider provider = getProvider(vendor, VAppProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult remove(String vendor, String vappName) {
        VAppProvider provider = getProvider(vendor, VAppProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(vappName);
    }

    public BocloudResult start(String vendor, String vappName) {
        VAppProvider provider = getProvider(vendor, VAppProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.start(vappName);
    }

    public BocloudResult stop(String vendor, String vappName) {
        VAppProvider provider = getProvider(vendor, VAppProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.stop(vappName);
    }

    public BocloudResult suspend(String vendor, String vappName) {
        VAppProvider provider = getProvider(vendor, VAppProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.suspend(vappName);
    }
}
