package com.bocloud.cmp.driver.contentlibrary;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.ServerModel;
import com.bocloud.cmp.provider.contentlibrary.LibraryProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 内容库
 *
 * @author wangyu
 * @version 5.0.0-SNAPSHOT
 * @since 2021/2/26
 */
@Service
public class LibraryDriver extends GenericDriver<LibraryProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult ovfDeploy(ServerModel model, String vendor) {
        LibraryProvider provider = getProvider(vendor, LibraryProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return provider.ovfDeploy(model);
    }
}
