package com.bocloud.cmp.driver.f5;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.f5.AddressTranslationProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * AddressTranslation 地址转化操作接口
 * 
 * @author liuyuanyuan
 *
 */
@Service("f5AddressTranslationDriver")
public class F5AddressTranslationDriver extends GenericDriver<AddressTranslationProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String category) {
		AddressTranslationProvider f5AddressTranslationProvider = getProvider(vendor, AddressTranslationProvider.class,
				repository);
		if (before(f5AddressTranslationProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return f5AddressTranslationProvider.list(category);
	}
}
