package com.bocloud.cmp.driver.f5;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.f5.DataGroupModel;
import com.bocloud.cmp.provider.f5.DataGroupProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 数据组
 *
 * @author lyy
 * @version 1.0
 * @date 2020/11/10 19:08
 */
@Service("f5DataGroupDriver")
public class F5DataGroupDriver extends GenericDriver<DataGroupProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String category, String vendor) {

        DataGroupProvider dataGroupProvider = getProvider(vendor, DataGroupProvider.class, repository);
        if (before(dataGroupProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return dataGroupProvider.list(category);
    }

    public BocloudResult create(String vendor, DataGroupModel dataGroupModel, String category) {
        DataGroupProvider dataGroupProvider = getProvider(vendor, DataGroupProvider.class, repository);
        if (before(dataGroupProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return dataGroupProvider.create(category, dataGroupModel);
    }

    public BocloudResult modify(String vendor, DataGroupModel dataGroupModel, String category) {
        DataGroupProvider dataGroupProvider = getProvider(vendor, DataGroupProvider.class, repository);
        if (before(dataGroupProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return dataGroupProvider.update(category, dataGroupModel);
    }

    public BocloudResult remove(String vendor, String name, String category) {
        DataGroupProvider dataGroupProvider = getProvider(vendor, DataGroupProvider.class, repository);
        if (before(dataGroupProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return dataGroupProvider.remove(category, name);
    }
}
