package com.bocloud.cmp.driver.f5;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.f5.DeviceManagementProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by liuyuanyuan on 2019/5/7 14:01
 */
@Service("f5DeviceManagementDriver")
public class F5DeviceManagementDriver extends GenericDriver<DeviceManagementProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult deviceGroup(String vendor, String url) {
        DeviceManagementProvider deviceManagementProvider = getProvider(vendor, DeviceManagementProvider.class, repository);
        if (before(deviceManagementProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return deviceManagementProvider.deviceGroup(url);
    }

    public BocloudResult device(String vendor, String url) {
        DeviceManagementProvider deviceManagementProvider = getProvider(vendor, DeviceManagementProvider.class, repository);
        if (before(deviceManagementProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return deviceManagementProvider.device(url);
    }

    public BocloudResult syncStats(String vendor, String url) {
        DeviceManagementProvider deviceManagementProvider = getProvider(vendor, DeviceManagementProvider.class, repository);
        if (before(deviceManagementProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return deviceManagementProvider.syncStats(url);
    }

    public BocloudResult sync(String vendor, JSONObject params) {
        DeviceManagementProvider deviceManagementProvider = getProvider(vendor, DeviceManagementProvider.class, repository);
        if (before(deviceManagementProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return deviceManagementProvider.sync(params);
    }

}
