package com.bocloud.cmp.driver.f5;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.f5.DnsResolversProvider;
import com.bocloud.common.model.BocloudResult;

@Service("f5DnsResolversDriver")
public class F5DnsResolversDriver extends GenericDriver<DnsResolversProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		DnsResolversProvider dnsResolversProvider = getProvider(vendor, DnsResolversProvider.class, repository);
		if (before(dnsResolversProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return dnsResolversProvider.list();
	}
}
