package com.bocloud.cmp.driver.f5;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.f5.RuleModel;
import com.bocloud.cmp.provider.f5.IRulesProvider;
import com.bocloud.common.model.BocloudResult;

@Service("f5IRulesDriver")
public class F5IRulesDriver extends GenericDriver<IRulesProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		IRulesProvider iRulesProvider = getProvider(vendor, IRulesProvider.class, repository);
		if (before(iRulesProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return iRulesProvider.list();
	}

	public BocloudResult create(String vendor, RuleModel ruleModel) {
		IRulesProvider iRulesProvider = getProvider(vendor, IRulesProvider.class, repository);
		if (before(iRulesProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return iRulesProvider.create(ruleModel);
	}

	public BocloudResult modify(String vendor, RuleModel ruleModel) {
		IRulesProvider iRulesProvider = getProvider(vendor, IRulesProvider.class, repository);
		if (before(iRulesProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return iRulesProvider.update(ruleModel);
	}

	public BocloudResult remove(String vendor, String name) {
		IRulesProvider iRulesProvider = getProvider(vendor, IRulesProvider.class, repository);
		if (before(iRulesProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return iRulesProvider.remove(name);
	}
}
