package com.bocloud.cmp.driver.f5;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.f5.MonitorModel;
import com.bocloud.cmp.provider.f5.MonitorProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * f5 monitor 操作接口实现类
 * 
 * @author liuyuanyuan
 *
 */
@Service("f5MonitorDriver")
public class F5MonitorDriver extends GenericDriver<MonitorProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String type) {
		MonitorProvider monitorProvider = getProvider(vendor, MonitorProvider.class, repository);
		if (before(monitorProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return monitorProvider.list(type);
	}

	public BocloudResult create(String vendor, MonitorModel monitorModel, String type) {
		MonitorProvider monitorProvider = getProvider(vendor, MonitorProvider.class, repository);
		if (before(monitorProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return monitorProvider.create(monitorModel, type);
	}

	public BocloudResult modify(String vendor, MonitorModel monitorModel, String type) {
		MonitorProvider monitorProvider = getProvider(vendor, MonitorProvider.class, repository);
		if (before(monitorProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return monitorProvider.update(monitorModel, type);
	}

	public BocloudResult remove(String vendor, String name, String type) {
		MonitorProvider monitorProvider = getProvider(vendor, MonitorProvider.class, repository);
		if (before(monitorProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return monitorProvider.remove(name, type);
	}
}
