package com.bocloud.cmp.driver.f5;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.f5.PartitionModel;
import com.bocloud.cmp.provider.f5.PartitionProvider;
import com.bocloud.common.model.BocloudResult;

@Service("f5PartitionDriver")
public class F5PartitionDriver extends GenericDriver<PartitionProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        PartitionProvider partitionProvider = getProvider(vendor, PartitionProvider.class, repository);
        if (before(partitionProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return partitionProvider.list();
    }

    public BocloudResult create(String vendor, PartitionModel partitionModel) {
        PartitionProvider partitionProvider = getProvider(vendor, PartitionProvider.class, repository);
        if (before(partitionProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return partitionProvider.create(partitionModel);
    }

    public BocloudResult remove(String vendor, String name) {
        PartitionProvider partitionProvider = getProvider(vendor, PartitionProvider.class, repository);
        if (before(partitionProvider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败!");
        }
        return partitionProvider.remove(name);
    }
}
