package com.bocloud.cmp.driver.f5;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.f5.ProfileModel;
import com.bocloud.cmp.provider.f5.ProfileProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * f5 profile 操作接口实现类
 * 
 * @author liuyuanyuan
 *
 */
@Service("f5ProfileDriver")
public class F5ProfileDriver extends GenericDriver<ProfileProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String category) {
		ProfileProvider profileProvider = getProvider(vendor, ProfileProvider.class, repository);
		if (before(profileProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return profileProvider.list(category);
	}

	public BocloudResult create(String vendor, ProfileModel profileModel, String category) {
		ProfileProvider profileProvider = getProvider(vendor, ProfileProvider.class, repository);
		if (before(profileProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return profileProvider.create(profileModel, category);
	}

	public BocloudResult modify(String vendor, ProfileModel profileModel, String category) {
		ProfileProvider profileProvider = getProvider(vendor, ProfileProvider.class, repository);
		if (before(profileProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return profileProvider.update(profileModel, category);
	}

	public BocloudResult remove(String vendor, String name, String category) {
		ProfileProvider profileProvider = getProvider(vendor, ProfileProvider.class, repository);
		if (before(profileProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return profileProvider.remove(name, category);
	}
}
