package com.bocloud.cmp.driver.f5;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.f5.VirtualServerModel;
import com.bocloud.cmp.provider.f5.VirtualServerProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * f5 VirtualServer 操作接口实现类
 * 
 * @author liuyuanyuan
 *
 */
@Service("f5VirtualServerDriver")
public class F5VirtualServerDriver extends GenericDriver<VirtualServerProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		VirtualServerProvider virtualServerProvider = getProvider(vendor, VirtualServerProvider.class, repository);
		if (before(virtualServerProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return virtualServerProvider.list();
	}

	public BocloudResult stats(String vendor, String vsName) {
		VirtualServerProvider virtualServerProvider = getProvider(vendor, VirtualServerProvider.class, repository);
		if (before(virtualServerProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return virtualServerProvider.stats(vsName);
	}

	public BocloudResult create(String vendor, VirtualServerModel virtualServerModel) {
		VirtualServerProvider virtualServerProvider = getProvider(vendor, VirtualServerProvider.class, repository);
		if (before(virtualServerProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return virtualServerProvider.create(virtualServerModel);
	}

	public BocloudResult modify(String vendor, VirtualServerModel virtualServerModel) {
		VirtualServerProvider virtualServerProvider = getProvider(vendor, VirtualServerProvider.class, repository);
		if (before(virtualServerProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return virtualServerProvider.update(virtualServerModel);
	}

	public BocloudResult remove(String vendor, String name) {
		VirtualServerProvider virtualServerProvider = getProvider(vendor, VirtualServerProvider.class, repository);
		if (before(virtualServerProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return virtualServerProvider.remove(name);
	}
}
