package com.bocloud.cmp.driver.f5;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.f5.VlansProvider;
import com.bocloud.common.model.BocloudResult;

@Service("f5VlansDriver")
public class F5VlansDriver extends GenericDriver<VlansProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		VlansProvider vlansProvider = getProvider(vendor, VlansProvider.class, repository);
		if (before(vlansProvider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败!");
		}
		return vlansProvider.list();
	}
}
