package com.bocloud.cmp.driver.fusionsphere;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.fusionsphere.UpLinkPortProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName: FusionsphereUpLinkPortDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/11/2 19:21
 */
@Service
public class FusionsphereUpLinkPortDriver extends GenericDriver<UpLinkPortProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor, String siteUri, String dvsUrn) {
        UpLinkPortProvider provider = getProvider(vendor, UpLinkPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.listBySwitcher(siteUri, dvsUrn);
    }


}