package com.bocloud.cmp.driver.groups;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.ResourceGroupModel;
import com.bocloud.cmp.provider.groups.ResourceGroupsProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: AzureResourceGroupDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2019/9/26 11:17
 */
@Service("resourceGroupDriver")
public class ResourceGroupDriver extends GenericDriver<ResourceGroupsProvider> {

    @Autowired
    private ProviderRepository repository;


    public BocloudResult list(String vendor, String region) {
        ResourceGroupsProvider provider = getProvider(vendor, ResourceGroupsProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list();
    }


    public BocloudResult create(String vendor, String region, ResourceGroupModel resourceGroupModel) {
        ResourceGroupsProvider provider = getProvider(vendor, ResourceGroupsProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(resourceGroupModel);
    }

    public BocloudResult detail(String vendor, String region, String resourceGroupName) {
        ResourceGroupsProvider provider = getProvider(vendor, ResourceGroupsProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(resourceGroupName);
    }

    public BocloudResult remove(String vendor, String region, String resourceGroupName) {
        ResourceGroupsProvider provider = getProvider(vendor, ResourceGroupsProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(resourceGroupName);
    }


}
