package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.ArpBindProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.ARPBindModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneArpBindDriver extends GenericDriver<ArpBindProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<List<ARPBindModel>> list(String vendorUuid) {
        ArpBindProvider provider = getProvider(vendorUuid, ArpBindProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.list();
    }
}
