package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.BlackServiceProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.BlackServiceModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneBlackServiceDriver extends GenericDriver<BlackServiceProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, BlackServiceModel blackServiceModel) {
        BlackServiceProvider provider = getProvider(vendorUuid, BlackServiceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(blackServiceModel);
    }

    public BocloudResult delete(String vendorUuid, BlackServiceModel blackServiceModel) {
        BlackServiceProvider provider = getProvider(vendorUuid, BlackServiceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(blackServiceModel);
    }
}
