package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.InterfaceProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.InterfaceModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneInterfaceDriver extends GenericDriver<InterfaceProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<List<InterfaceModel>> list(String vendorUuid) {
        InterfaceProvider provider = getProvider(vendorUuid, InterfaceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult<>(false, "平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult create(String vendorUuid, InterfaceModel interfaceModel) {
        InterfaceProvider provider = getProvider(vendorUuid, InterfaceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(interfaceModel);
    }

    public BocloudResult delete(String vendorUuid, InterfaceModel interfaceModel) {
        InterfaceProvider provider = getProvider(vendorUuid, InterfaceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(interfaceModel);
    }

    public BocloudResult update(String vendorUuid, InterfaceModel interfaceModel) {
        InterfaceProvider provider = getProvider(vendorUuid, InterfaceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.update(interfaceModel);
    }
}
