package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.LocalUserProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.LocalUserModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneLocalUserDriver extends GenericDriver<LocalUserProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, LocalUserModel localUserModel) {
        LocalUserProvider provider = getProvider(vendorUuid, LocalUserProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(localUserModel);
    }

    public BocloudResult delete(String vendorUuid, Long id) {
        LocalUserProvider provider = getProvider(vendorUuid, LocalUserProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(id);
    }

    public BocloudResult update(String vendorUuid, LocalUserModel localUserModel) {
        LocalUserProvider provider = getProvider(vendorUuid, LocalUserProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.update(localUserModel);
    }
}
