package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.LocalUserGroupProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.LocalUserGroupModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneLocalUserGroupDriver extends GenericDriver<LocalUserGroupProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, LocalUserGroupModel localUserGroupModel) {
        LocalUserGroupProvider provider = getProvider(vendorUuid, LocalUserGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(localUserGroupModel);
    }

    public BocloudResult delete(String vendorUuid, LocalUserGroupModel localUserGroupModel) {
        LocalUserGroupProvider provider = getProvider(vendorUuid, LocalUserGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(localUserGroupModel);
    }

    public BocloudResult update(String vendorUuid, LocalUserGroupModel localUserGroupModel) {
        LocalUserGroupProvider provider = getProvider(vendorUuid, LocalUserGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.update(localUserGroupModel);
    }
}
