package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.PolicyRouteProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.PolicyRouteModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStonePolicyRouteDriver extends GenericDriver<PolicyRouteProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, PolicyRouteModel policyRouteModel) {
        PolicyRouteProvider provider = getProvider(vendorUuid, PolicyRouteProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(policyRouteModel);
    }

    public BocloudResult delete(String vendorUuid, PolicyRouteModel policyRouteModel) {
        PolicyRouteProvider provider = getProvider(vendorUuid, PolicyRouteProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(policyRouteModel);
    }
}
