package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.RouteProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.VirtualRouteRibv4Model;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneRouteDriver extends GenericDriver<RouteProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, VirtualRouteRibv4Model routeRibv4Model) {
        RouteProvider provider = getProvider(vendorUuid, RouteProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(routeRibv4Model);
    }

    public BocloudResult delete(String vendorUuid, VirtualRouteRibv4Model routeRibv4Model) {
        RouteProvider provider = getProvider(vendorUuid, RouteProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(routeRibv4Model);
    }
}
