package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.SNMPHostProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.SNMPHostModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class HillStoneSNMPHostDriver extends GenericDriver<SNMPHostProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult configure(String vendorUuid, SNMPHostModel snmpHostModel) {
        SNMPHostProvider provider = getProvider(vendorUuid, SNMPHostProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.configure(snmpHostModel);
    }
}
