package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.SNMPProxyProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.SNMPProxyModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class HillStoneSNMPProxyDriver extends GenericDriver<SNMPProxyProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult configure(String vendorUuid, SNMPProxyModel snmpProxyModel) {
        SNMPProxyProvider provider = getProvider(vendorUuid, SNMPProxyProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.configure(snmpProxyModel);
    }
}
