package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.SNMPV3GroupProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.SNMPV3GroupModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class HillStoneSNMPV3GroupDriver extends GenericDriver<SNMPV3GroupProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult configure(String vendorUuid, SNMPV3GroupModel snmpv3GroupModel) {
        SNMPV3GroupProvider provider = getProvider(vendorUuid, SNMPV3GroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.configure(snmpv3GroupModel);
    }
}
