package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.SNMPV3UserProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.SNMPV3UserModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class HillStoneSNMPV3UserDriver extends GenericDriver<SNMPV3UserProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult configure(String vendorUuid, SNMPV3UserModel snmpProxyModel) {
        SNMPV3UserProvider provider = getProvider(vendorUuid, SNMPV3UserProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.configure(snmpProxyModel);
    }
}
