package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.SafeZoneProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.SafeZoneModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneSafeZoneDriver extends GenericDriver<SafeZoneProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, SafeZoneModel safeZoneModel) {
        SafeZoneProvider provider = getProvider(vendorUuid, SafeZoneProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(safeZoneModel);
    }

    public BocloudResult delete(String vendorUuid, SafeZoneModel safeZoneModel) {
        SafeZoneProvider provider = getProvider(vendorUuid, SafeZoneProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(safeZoneModel);
    }
}
