package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.SecurityPolicyProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.SecurityPolicyModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneSecurityPolicyDriver extends GenericDriver<SecurityPolicyProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, SecurityPolicyModel securityPolicyModel, boolean isDynamic) {
        SecurityPolicyProvider provider = getProvider(vendorUuid, SecurityPolicyProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(securityPolicyModel, isDynamic);
    }

    public BocloudResult delete(String vendorUuid, Long policyId) {
        SecurityPolicyProvider provider = getProvider(vendorUuid, SecurityPolicyProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(policyId);
    }

    public BocloudResult move(String vendorUuid, Long policyId, String type) {
        SecurityPolicyProvider provider = getProvider(vendorUuid, SecurityPolicyProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.move(policyId, type);
    }
}
