package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.ServiceBookProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.ServiceBookModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneServiceBookDriver extends GenericDriver<ServiceBookProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, ServiceBookModel serviceBookModel) {
        ServiceBookProvider provider = getProvider(vendorUuid, ServiceBookProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(serviceBookModel);
    }

    public BocloudResult remove(String vendorUuid, ServiceBookModel serviceBookModel) {
        ServiceBookProvider provider = getProvider(vendorUuid, ServiceBookProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(serviceBookModel);
    }

    public BocloudResult modify(String vendorUuid, ServiceBookModel serviceBookModel) {
        ServiceBookProvider provider = getProvider(vendorUuid, ServiceBookProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(serviceBookModel);
    }
}
