package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.ServiceGroupProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.ServiceGroupModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneServiceGroupDriver extends GenericDriver<ServiceGroupProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, ServiceGroupModel serviceGroupModel) {
        ServiceGroupProvider provider = getProvider(vendorUuid, ServiceGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(serviceGroupModel);
    }

    public BocloudResult remove(String vendorUuid, ServiceGroupModel serviceGroupModel) {
        ServiceGroupProvider provider = getProvider(vendorUuid, ServiceGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(serviceGroupModel);
    }
}
