package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.SourceNatProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.VirtualRouteSourceNatModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneSourceNatDriver extends GenericDriver<SourceNatProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, VirtualRouteSourceNatModel virtualRouteSourceNatModel) {
        SourceNatProvider provider = getProvider(vendorUuid, SourceNatProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(virtualRouteSourceNatModel);
    }

    public BocloudResult delete(String vendorUuid, Long ruleId) {
        SourceNatProvider provider = getProvider(vendorUuid, SourceNatProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(ruleId);
    }
}
