package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.SystemConfigProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class HillStoneSystemConfigDriver extends GenericDriver<SystemConfigProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendorUuid) {
        SystemConfigProvider provider = getProvider(vendorUuid, SystemConfigProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult getNetworkParameters(String vendorUuid) {
        SystemConfigProvider provider = getProvider(vendorUuid, SystemConfigProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.getNetworkParameters();
    }

    public BocloudResult getAlg(String vendorUuid) {
        SystemConfigProvider provider = getProvider(vendorUuid, SystemConfigProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.getAlg();
    }
}
