package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.SystemUserProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.SystemUserModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneSystemUserDriver extends GenericDriver<SystemUserProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, SystemUserModel systemUserModel) {
        SystemUserProvider provider = getProvider(vendorUuid, SystemUserProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(systemUserModel);
    }

    public BocloudResult modify(String vendorUuid, SystemUserModel systemUserModel) {
        SystemUserProvider provider = getProvider(vendorUuid, SystemUserProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(systemUserModel);
    }

    public BocloudResult delete(String vendorUuid, SystemUserModel systemUserModel) {
        SystemUserProvider provider = getProvider(vendorUuid, SystemUserProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(systemUserModel);
    }
}
