package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.AddressBookProvider;
import com.bocloud.cmp.provider.hillstone.VpnIpsecConfigProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.AddressBookModel;
import com.bocloud.nms.model.hillstone.VpnIpsecConfigModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneVpnIpsecConfigDriver extends GenericDriver<VpnIpsecConfigProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, VpnIpsecConfigModel vpnIpsecConfigModel) {
        VpnIpsecConfigProvider provider = getProvider(vendorUuid, VpnIpsecConfigProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(vpnIpsecConfigModel);
    }

    public BocloudResult delete(String vendorUuid, VpnIpsecConfigModel vpnIpsecConfigModel) {
        VpnIpsecConfigProvider provider = getProvider(vendorUuid, VpnIpsecConfigProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(vpnIpsecConfigModel);
    }

    public BocloudResult update(String vendorUuid, VpnIpsecConfigModel vpnIpsecConfigModel) {
        VpnIpsecConfigProvider provider = getProvider(vendorUuid, VpnIpsecConfigProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.update(vpnIpsecConfigModel);
    }
}
