package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.AddressBookProvider;
import com.bocloud.cmp.provider.hillstone.VpnIpsecPeerProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.AddressBookModel;
import com.bocloud.nms.model.hillstone.VpnIpsecConfigModel;
import com.bocloud.nms.model.hillstone.VpnIpsecPeerModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneVpnIpsecPeerDriver extends GenericDriver<VpnIpsecPeerProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, VpnIpsecPeerModel vpnIpsecPeerModel) {
        VpnIpsecPeerProvider provider = getProvider(vendorUuid, VpnIpsecPeerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(vpnIpsecPeerModel);
    }

    public BocloudResult delete(String vendorUuid, VpnIpsecPeerModel vpnIpsecPeerModel) {
        VpnIpsecPeerProvider provider = getProvider(vendorUuid, VpnIpsecPeerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(vpnIpsecPeerModel);
    }

    public BocloudResult update(String vendorUuid, VpnIpsecPeerModel vpnIpsecPeerModel) {
        VpnIpsecPeerProvider provider = getProvider(vendorUuid, VpnIpsecPeerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.update(vpnIpsecPeerModel);
    }
}
