package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.AddressBookProvider;
import com.bocloud.cmp.provider.hillstone.VpnIpsecProposal1Provider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.AddressBookModel;
import com.bocloud.nms.model.hillstone.VpnIpsecConfigModel;
import com.bocloud.nms.model.hillstone.VpnIpsecProposal1Model;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneVpnIpsecProposal1Driver extends GenericDriver<VpnIpsecProposal1Provider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, VpnIpsecProposal1Model vpnIpsecProposal1Model) {
        VpnIpsecProposal1Provider provider = getProvider(vendorUuid, VpnIpsecProposal1Provider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(vpnIpsecProposal1Model);
    }

    public BocloudResult delete(String vendorUuid, VpnIpsecProposal1Model vpnIpsecProposal1Model) {
        VpnIpsecProposal1Provider provider = getProvider(vendorUuid, VpnIpsecProposal1Provider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(vpnIpsecProposal1Model);
    }

    public BocloudResult update(String vendorUuid, VpnIpsecProposal1Model vpnIpsecProposal1Model) {
        VpnIpsecProposal1Provider provider = getProvider(vendorUuid, VpnIpsecProposal1Provider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.update(vpnIpsecProposal1Model);
    }
}
