package com.bocloud.cmp.driver.hillstone;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hillstone.AddressBookProvider;
import com.bocloud.cmp.provider.hillstone.VpnIpsecProposal2Provider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.hillstone.AddressBookModel;
import com.bocloud.nms.model.hillstone.VpnIpsecProposal1Model;
import com.bocloud.nms.model.hillstone.VpnIpsecProposal2Model;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/1/14 10:56 上午
 */
@Service
public class HillStoneVpnIpsecProposal2Driver extends GenericDriver<VpnIpsecProposal2Provider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, VpnIpsecProposal2Model vpnIpsecProposal2Model) {
        VpnIpsecProposal2Provider provider = getProvider(vendorUuid, VpnIpsecProposal2Provider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(vpnIpsecProposal2Model);
    }

    public BocloudResult delete(String vendorUuid, VpnIpsecProposal2Model vpnIpsecProposal2Model) {
        VpnIpsecProposal2Provider provider = getProvider(vendorUuid, VpnIpsecProposal2Provider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(vpnIpsecProposal2Model);
    }

    public BocloudResult update(String vendorUuid, VpnIpsecProposal2Model vpnIpsecProposal2Model) {
        VpnIpsecProposal2Provider provider = getProvider(vendorUuid, VpnIpsecProposal2Provider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.update(vpnIpsecProposal2Model);
    }
}
