package com.bocloud.cmp.driver.hmc;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hmc.CommonProvider;
import com.bocloud.common.model.BocloudResult;

@Service("hmcCommonDriver")
public class HmcCommonDriver extends GenericDriver<CommonProvider> {
    @Autowired
    private ProviderRepository repository;
    
    public BocloudResult getJobStatus(String vendorUuid, String jobId) {
        CommonProvider provider = getProvider(vendorUuid, CommonProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.getJobStatus(jobId);
    }
    
    public BocloudResult getJobStatus(String vendorUuid, String jobId, long timeout) {
        CommonProvider provider = getProvider(vendorUuid, CommonProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.getJobStatus(jobId, timeout);
    }
}
