package com.bocloud.cmp.driver.hmc;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.hmc.HmcHostEthernetAdapterModel;
import com.bocloud.cmp.provider.hmc.HEAProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * 主机以太网适配器Driver
 * <p>
 * HEA:HostEthernetAdapter
 * </p>
 * 
 * @author sxp
 * @since Nov 20, 2018
 */
@Service("hmcHEADriver")
public class HmcHEADriver extends GenericDriver<HEAProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult updatePhysicalPorts(String vendorUuid, HmcHostEthernetAdapterModel hmcHostEthernetAdapter,
            String serverUuid, String heaUuid) {
        HEAProvider provider = getProvider(vendorUuid, HEAProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.updatePhysicalPorts(hmcHostEthernetAdapter, serverUuid, heaUuid);
    }

}
