package com.bocloud.cmp.driver.hmc;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.hmc.NetworkBridgeProvider;
import com.bocloud.cmp.provider.hmc.PartitionProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("hmcVirtualBridgeDriver")
public class HmcNetworkBridgeDriver extends GenericDriver<NetworkBridgeProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult getNetworkBridge(String vendorUuid, String ManagedSystemUuid) {
        NetworkBridgeProvider provider = getProvider(vendorUuid, NetworkBridgeProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.getNetworkBridge(ManagedSystemUuid);
    }
}
