package com.bocloud.cmp.driver.hmc;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.hmc.HmcPartitionModel;
import com.bocloud.cmp.provider.hmc.PartitionProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 分区Driver
 * 
 * @author weiwei
 * @since Nov 20, 2018
 */
@Deprecated
@Service("hmcPartitionDriver")
public class HmcPartitionDriver extends GenericDriver<PartitionProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult createLogicalPartition(String vendorUuid, String managedSystemUuid, HmcPartitionModel par) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.createLogicalPartition(managedSystemUuid, par);
    }

    public BocloudResult createVirtualIOServer(String vendorUuid, String managedSystemUuid, HmcPartitionModel par) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.createVirtualIOServer(managedSystemUuid, par);
    }

    public BocloudResult delete(String vendorUuid, String managedSystemUuid, String partitionUuid, Boolean isVios) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(managedSystemUuid, partitionUuid, isVios);
    }

    public BocloudResult updateLogicalPartition(String vendorUuid, HmcPartitionModel partition, String managedSystemUuid,
            String partitionUuid) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.updateLogicalPartition(partition, managedSystemUuid, partitionUuid);
    }

    public BocloudResult updateVirtualIOServer(String vendorUuid, HmcPartitionModel partition, String managedSystemUuid,
            String partitionUuid) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.updateVirtualIOServer(partition, managedSystemUuid, partitionUuid);
    }

    public BocloudResult getPartitionAttribute(String vendorUuid, String partitionUuid, Boolean isVios) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.getPartitionAttribute(partitionUuid, isVios);
    }

    public BocloudResult powerOffPartition(String vendorUuid, String uuid, Boolean isVios) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.powerOffPartition(uuid, isVios);
    }

    public BocloudResult restartPartition(String vendorUuid, String uuid, Boolean isVios) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.restartPartition(uuid, isVios);
    }

    public BocloudResult powerOnPartition(String vendorUuid, String uuid, String profileUuid, Boolean isVios) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.powerOnPartition(uuid, profileUuid, isVios);
    }

    public BocloudResult queryPartitionState(String vendorUuid, String uuid, Boolean isVios) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.queryPartitionState(uuid, isVios);
    }

    public BocloudResult queryPartitionRMCState(String vendorUuid, String uuid, Boolean isVios) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.queryPartitionRMCState(uuid, isVios);
    }

    public BocloudResult getVirtualScsiAdapters(String vendorUuid, String href) {
        PartitionProvider provider = getProvider(vendorUuid, PartitionProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.getVirtualScsiAdapters(href);
    }
}
