package com.bocloud.cmp.driver.hmc;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.hmc.HmcPartitionModel;
import com.bocloud.cmp.model.hmc.HmcProfileModel;
import com.bocloud.cmp.provider.hmc.ProfileProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 概要文件Driver
 * 
 * @author sxp
 * @since Nov 20, 2018
 */
@Service("hmcProfileDriver")
public class HmcProfileDriver extends GenericDriver<ProfileProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendorUuid, HmcPartitionModel partition, HmcProfileModel profile) {
        ProfileProvider provider = getProvider(vendorUuid, ProfileProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.create(partition, profile);
    }

    public BocloudResult update(String vendorUuid, HmcProfileModel profile, boolean isVIOS, String partitionUuid,
            String profileUuid) {
        ProfileProvider provider = getProvider(vendorUuid, ProfileProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.update(profile, isVIOS, partitionUuid, profileUuid);
    }

    public BocloudResult delete(String vendorUuid, boolean isVios, String partitionUuid, String profileUuid) {
        ProfileProvider provider = getProvider(vendorUuid, ProfileProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.delete(isVios, partitionUuid, profileUuid);
    }

    public BocloudResult getProfile(String vendorUuid, boolean isVios, String partitionUuid, String profileUuid) {
        ProfileProvider provider = getProvider(vendorUuid, ProfileProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.getProfile(isVios, partitionUuid, profileUuid);
    }

    public BocloudResult getProfile(String vendorUuid, boolean isVios, String partitionUuid) {
        ProfileProvider provider = getProvider(vendorUuid, ProfileProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.getProfile(isVios, partitionUuid);
    }

}
