package com.bocloud.cmp.driver.hmc;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.hmc.sdk.module.ManagedSystem;
import com.bocloud.cmp.provider.hmc.ServerProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 物理服务器Driver
 * 
 * @author sxp
 * @since Nov 20, 2018
 */
@Service("hmcServerDriver")
public class HmcServerDriver extends GenericDriver<ServerProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult get(String vendorUuid){
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.get();
    }

    public BocloudResult update(String vendorUuid, String managedSystemUuid, ManagedSystem managedSystem){
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.update(managedSystemUuid, managedSystem);
    }

    public BocloudResult powerOnManagedSystem(String vendorUuid, String managedSystemUuid) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.powerOnManagedSystem(managedSystemUuid);
    }

    public BocloudResult powerOffManagedSystem(String vendorUuid, String managedSystemUuid) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.powerOffManagedSystem(managedSystemUuid);
    }

    public BocloudResult resetConnection(String vendorUuid, String managedSystemUuid) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.resetConnection(managedSystemUuid);
    }

    public BocloudResult removeConnection(String vendorUuid, String managedSystemUuid) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.removeConnection(managedSystemUuid);
    }

    public BocloudResult powerOn(String vendorUuid, String managedSystemUuid) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.powerOn(managedSystemUuid);
    }
    
    public BocloudResult powerOff(String vendorUuid, String managedSystemUuid) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.powerOff(managedSystemUuid);
    }

    public BocloudResult queryManagedSystemState(String vendorUuid, String managedSystemUuid) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.queryManagedSystemState(managedSystemUuid);
    }

    public BocloudResult queryManagedSystemAttribute(String vendorUuid, String managedSystemUuid) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.queryManagedSystemAttribute(managedSystemUuid);
    }

    public BocloudResult queryManagementConsoleUuid(String vendorUuid) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.queryManagementConsoleUuid();
    }

    public BocloudResult addManagedSystem(String vendorUuid, String consoleUuid, String hostIp, String password) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.addManagedSystem(consoleUuid, hostIp, password);
    }

    public BocloudResult removeManagedSystemConnection(String vendorUuid, String consoleUuid,
            String managedSystemUuid) {
        ServerProvider provider = getProvider(vendorUuid, ServerProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.removeManagedSystemConnection(consoleUuid, managedSystemUuid);
    }

}
