package com.bocloud.cmp.driver.hmc;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.hmc.HmcVirtualFibreChannelMappingModel;
import com.bocloud.cmp.provider.hmc.VirtualFibreChannelMappingProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 虚拟光纤通道
 * @author luyanchao
 * @since 2018/12/18 17:24
 */
@Service("hmcVirtualFibreChannelDriver")
public class HmcVirtualFibreChannelMappingDriver extends GenericDriver<VirtualFibreChannelMappingProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult addVfcToVios(String vendorUuid, String managedSystemUuid, String viosUuid, HmcVirtualFibreChannelMappingModel mapping) {
        VirtualFibreChannelMappingProvider provider = getProvider(vendorUuid, VirtualFibreChannelMappingProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.addVfcToVios(managedSystemUuid, viosUuid, mapping);
    }

    public BocloudResult removeVfcFromVios(String vendorUuid, String managedSystemUuid, String viosUuid, HmcVirtualFibreChannelMappingModel mapping) {
        VirtualFibreChannelMappingProvider provider = getProvider(vendorUuid, VirtualFibreChannelMappingProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.removeVfcFromVios(managedSystemUuid, viosUuid, mapping);
    }

    public BocloudResult getVfcFromPartition(String vendorUuid, String partitionUuid) {
        VirtualFibreChannelMappingProvider provider = getProvider(vendorUuid, VirtualFibreChannelMappingProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.getVfcFromPartition(partitionUuid);
    }

}
