package com.bocloud.cmp.driver.hmc;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.hmc.HmcVirtualSwitchModel;
import com.bocloud.cmp.provider.hmc.VirtualNetworkProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 虚拟网络Driver
 * 
 * @author sxp
 * @since Nov 20, 2018
 */
@Service("hmcVirtualNetworkDriver")
public class HmcVirtualNetworkDriver extends GenericDriver<VirtualNetworkProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult createVirtualSwitch(String vendorUuid, HmcVirtualSwitchModel virtualSwitch, String serverUuid) {
        VirtualNetworkProvider provider = getProvider(vendorUuid, VirtualNetworkProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.createVirtualSwitch(virtualSwitch, serverUuid);
    }

    public BocloudResult deleteVirtualSwitch(String vendorUuid, String serverUuid, String vswitchUuid) {
        VirtualNetworkProvider provider = getProvider(vendorUuid, VirtualNetworkProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.deleteVirtualSwitch(serverUuid, vswitchUuid);
    }

    public BocloudResult updateVirtualSwitch(String vendorUuid, HmcVirtualSwitchModel virtualSwitch, String serverUuid,
                                             String vswitchUuid) {
        VirtualNetworkProvider provider = getProvider(vendorUuid, VirtualNetworkProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.updateVirtualSwitch(virtualSwitch, serverUuid, vswitchUuid);
    }

    public BocloudResult getClientNetworkAdapter(String vendorUuid, String lpauUuid) {
        VirtualNetworkProvider provider = getProvider(vendorUuid, VirtualNetworkProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.getClientNetworkAdapter(lpauUuid);
    }

}
