package com.bocloud.cmp.driver.horizon;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.horizon.VmwareHorizonDesktopPoolModel;
import com.bocloud.cmp.provider.horizon.HorizonDesktopPoolProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * horizon桌面池
 * 
 * @author HP
 *
 */
@Service("horizonDesktopPoolDriver")
public class HorizonDesktopPoolDriver extends GenericDriver<HorizonDesktopPoolProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		HorizonDesktopPoolProvider provider = getProvider(vendor, HorizonDesktopPoolProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, VmwareHorizonDesktopPoolModel model) {
		HorizonDesktopPoolProvider provider = getProvider(vendor, HorizonDesktopPoolProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

}
