package com.bocloud.cmp.driver.horizon;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.horizon.VmwareHorizonFarmModel;
import com.bocloud.cmp.provider.horizon.HorizonFarmProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * horizon场
 * 
 * @author HP
 *
 */
@Service("horizonFarmDriver")
public class HorizonFarmDriver extends GenericDriver<HorizonFarmProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		HorizonFarmProvider provider = getProvider(vendor, HorizonFarmProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, VmwareHorizonFarmModel model) {
		HorizonFarmProvider provider = getProvider(vendor, HorizonFarmProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

}
