package com.bocloud.cmp.driver.horizon;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.horizon.HorizonSessionProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * horizon会话
 * 
 * @author HP
 *
 */
@Service("horizonSessionDriver")
public class HorizonSessionDriver extends GenericDriver<HorizonSessionProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		HorizonSessionProvider provider = getProvider(vendor, HorizonSessionProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list();
	}

}
