package com.bocloud.cmp.driver.horizon;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.horizon.HorizonUserOrGroupProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * horizon 用户，组管理
 * 
 * @author HP
 *
 */
@Service("horizonUserOrGroupDriver")
public class HorizonUserOrGroupDriver extends GenericDriver<HorizonUserOrGroupProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, Boolean groupOnly) {
		HorizonUserOrGroupProvider provider = getProvider(vendor, HorizonUserOrGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list(groupOnly);
	}

}
