package com.bocloud.cmp.driver.horizon;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.horizon.HorizonVcenterProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * horizon vcenter管理
 * 
 * @author HP
 *
 */
@Service("horizonVcenterDriver")
public class HorizonVcenterDriver extends GenericDriver<HorizonVcenterProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		HorizonVcenterProvider provider = getProvider(vendor, HorizonVcenterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list();
	}

}
