package com.bocloud.cmp.driver.jumpserver;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.jumpserver.DangerCmd;
import com.bocloud.cmp.provider.jumpserver.DangerCmdProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @description:
 * @author: Li Yaohui
 * @since: 2021/5/11 4:21 下午
 */
@Service
public class DangerCmdDriver extends GenericDriver<DangerCmdProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor, Integer page, Integer size) {
        DangerCmdProvider provider = getProvider(vendor, DangerCmdProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.list(page, size);
    }

    public BocloudResult create(String vendor, DangerCmd dangerCmd) {
        DangerCmdProvider provider = getProvider(vendor, DangerCmdProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.create(dangerCmd);
    }

    public BocloudResult modify(String vendor, DangerCmd dangerCmd) {
        DangerCmdProvider provider = getProvider(vendor, DangerCmdProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.modify(dangerCmd);
    }

    public BocloudResult remove(String vendor, Long id) {
        DangerCmdProvider provider = getProvider(vendor, DangerCmdProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.remove(id);
    }

    public BocloudResult detail(String vendor, Long id) {
        DangerCmdProvider provider = getProvider(vendor, DangerCmdProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.detail(id);
    }
}
