package com.bocloud.cmp.driver.jumpserver;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.DepartmentBean;
import com.bocloud.cmp.provider.jumpserver.DepartmentProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class DepartmentDriver extends GenericDriver<DepartmentProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        DepartmentProvider provider = getProvider(vendor, DepartmentProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult create(String vendor, DepartmentBean departmentBean) {
        DepartmentProvider provider = getProvider(vendor, DepartmentProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.create(departmentBean.getName(), departmentBean.getParent().getId());
    }

    public BocloudResult modify(String vendor, DepartmentBean departmentBean) {
        DepartmentProvider provider = getProvider(vendor, DepartmentProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.modify(departmentBean);
    }

    public BocloudResult detail(String vendor, Long departmentBeanId) {
        DepartmentProvider provider = getProvider(vendor, DepartmentProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.detail(departmentBeanId);
    }

    /**
     * V335
     *
     * @param vendor
     * @param departmentBeanId
     * @param name
     * @return
     */
    public BocloudResult detail(String vendor, Long departmentBeanId, String name) {
        DepartmentProvider provider = getProvider(vendor, DepartmentProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.detail(departmentBeanId, name);
    }

    public BocloudResult remove(String vendor, DepartmentBean departmentBean) {
        DepartmentProvider provider = getProvider(vendor, DepartmentProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.remove(departmentBean);
    }
}
