package com.bocloud.cmp.driver.jumpserver;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.jumpserver.Device;
import com.bocloud.cmp.model.jumpserver.Misc;
import com.bocloud.cmp.provider.jumpserver.DeviceProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class DeviceDriver extends GenericDriver<DeviceProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult<List<Device>> list(String vendor, int deviceType, String name) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.list(deviceType, name);
    }

    public BocloudResult list(String vendor) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult<Device> create(String vendor, Device device) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.create(device);
    }

    public BocloudResult<Device> modify(String vendor, Device device) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.modify(device);
    }

    public BocloudResult<Device> remove(String vendor, Device device) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.remove(device);
    }

    public BocloudResult<Device> detail(String vendor, Device device) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.detail(device);
    }

    public BocloudResult<String> access(String vendor, Long id, String protocol, String account, String userAgent, Misc misc) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.access(id, protocol, account, userAgent, misc);
    }

    public BocloudResult<String> accessClient(String vendor, String type) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.accessClient(type);
    }

    public BocloudResult<String> addAccount(String vendor, Device device) {
        DeviceProvider provider = getProvider(vendor, DeviceProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.addAccount(device);
    }
}
