package com.bocloud.cmp.driver.jumpserver;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.jumpserver.User;
import com.bocloud.cmp.provider.jumpserver.UserProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class JumpserverUserDriver extends GenericDriver<UserProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, User user) {
        UserProvider provider = getProvider(vendor, UserProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.create(user);
    }

    public BocloudResult delete(String vendor, Long id) {
        UserProvider provider = getProvider(vendor, UserProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.delete(id);
    }

    public BocloudResult update(String vendor, User user) {
        UserProvider provider = getProvider(vendor, UserProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.update(user);
    }
}
