package com.bocloud.cmp.driver.jumpserver;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.jumpserver.ResourceGroup;
import com.bocloud.cmp.provider.jumpserver.ResourceGroupProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("jumpserverResourceGroupDriver")
public class ResourceGroupDriver extends GenericDriver<ResourceGroupProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        ResourceGroupProvider provider = getProvider(vendor, ResourceGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult create(String vendor, ResourceGroup resourceGroup) {
        ResourceGroupProvider provider = getProvider(vendor, ResourceGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.create(resourceGroup);
    }

    public BocloudResult modify(String vendor, ResourceGroup resourceGroup) {
        ResourceGroupProvider provider = getProvider(vendor, ResourceGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.modify(resourceGroup);
    }

    public BocloudResult unRelate(String vendor, Long groupId, List<Long> deviceIds) {
        ResourceGroupProvider provider = getProvider(vendor, ResourceGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.unRelate(groupId, deviceIds);
    }

    public BocloudResult detail(String vendor, ResourceGroup resourceGroup) {
        ResourceGroupProvider provider = getProvider(vendor, ResourceGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.detail(resourceGroup);
    }

    public BocloudResult relate(String vendor, Long groupId, List<Long> deviceIds) {
        ResourceGroupProvider provider = getProvider(vendor, ResourceGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.relate(groupId, deviceIds);
    }

    public BocloudResult delete(String vendor, Long groupId) {
        ResourceGroupProvider provider = getProvider(vendor, ResourceGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.delete(groupId);
    }

    public BocloudResult getByName(String vendor, String name) {
        ResourceGroupProvider provider = getProvider(vendor, ResourceGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.getByName(name);
    }
}
