package com.bocloud.cmp.driver.jumpserver;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.jumpserver.Rule;
import com.bocloud.cmp.provider.jumpserver.RuleProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class RuleDriver extends GenericDriver<RuleProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult<List<Rule>> list(String vendor) {
		RuleProvider provider = getProvider(vendor, RuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult<Rule> create(String vendor, Rule rule) {
		RuleProvider provider = getProvider(vendor, RuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(rule);
	}

	public BocloudResult<Rule> modify(String vendor, Rule rule) {
		RuleProvider provider = getProvider(vendor, RuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.modify(rule);
	}

	public BocloudResult<?> remove(String vendor, Rule rule) {
		RuleProvider provider = getProvider(vendor, RuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(rule);
	}
}
