package com.bocloud.cmp.driver.jumpserver;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.jumpserver.User;
import com.bocloud.cmp.model.jumpserver.UserGroup;
import com.bocloud.cmp.provider.jumpserver.UserGroupProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class UserGroupDriver extends GenericDriver<UserGroupProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult<List<UserGroup>> list(String vendor) {
		UserGroupProvider provider = getProvider(vendor, UserGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult<UserGroup> create(String vendor, UserGroup model) {
		UserGroupProvider provider = getProvider(vendor, UserGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult<UserGroup> modify(String vendor, UserGroup model) {
		UserGroupProvider provider = getProvider(vendor, UserGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult<?> remove(String vendor, UserGroup model) {
		UserGroupProvider provider = getProvider(vendor, UserGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult<?> addUsers(String vendor, UserGroup group, List<User> users) {
		UserGroupProvider provider = getProvider(vendor, UserGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.addUsers(group, users);
	}

	public BocloudResult<?> removeUsers(String vendor, UserGroup group, List<User> users) {
		UserGroupProvider provider = getProvider(vendor, UserGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.removeUsers(group, users);
	}
}
