package com.bocloud.cmp.driver.kubernetes;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.kubernetes.DaemonSetModel;
import com.bocloud.cmp.provider.kubernetes.DaemonSetProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * k8s deployment
 * 
 * @时间 2019年8月21日
 */
@Service("daemonSetDriver")
public class DaemonSetDriver extends GenericDriver<DaemonSetProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		DaemonSetProvider provider = getProvider(vendor, DaemonSetProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, DaemonSetModel model) {
		DaemonSetProvider provider = getProvider(vendor, DaemonSetProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(DaemonSetModel model, String vendor) {
		DaemonSetProvider provider = getProvider(vendor, DaemonSetProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult detail(DaemonSetModel model, String vendor) {
		DaemonSetProvider provider = getProvider(vendor, DaemonSetProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.detail(model);
	}

	public BocloudResult modify(String vendor, DaemonSetModel model) {
		DaemonSetProvider provider = getProvider(vendor, DaemonSetProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(model);
	}

}
