package com.bocloud.cmp.driver.kubernetes;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.kubernetes.DeploymentModel;
import com.bocloud.cmp.provider.kubernetes.DeploymentProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * k8s deployment
 * 
 * @时间 2019年8月21日
 */
@Service("deploymentDriver")
public class DeploymentDriver extends GenericDriver<DeploymentProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		DeploymentProvider provider = getProvider(vendor, DeploymentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, DeploymentModel model) {
		DeploymentProvider provider = getProvider(vendor, DeploymentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(DeploymentModel model, String vendor) {
		DeploymentProvider provider = getProvider(vendor, DeploymentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult detail(DeploymentModel model, String vendor) {
		DeploymentProvider provider = getProvider(vendor, DeploymentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.detail(model);
	}

	public BocloudResult modify(String vendor, DeploymentModel model) {
		DeploymentProvider provider = getProvider(vendor, DeploymentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult extendReplicas(String vendor, DeploymentModel model) {
		DeploymentProvider provider = getProvider(vendor, DeploymentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.extendReplicas(model);
	}

}
