package com.bocloud.cmp.driver.kubernetes;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.kubernetes.NamespaceModel;
import com.bocloud.cmp.provider.kubernetes.NamespaceProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * k8s namespace
 * 
 * @时间 2019年8月21日
 */
@Service("namespaceDriver")
public class NamespaceDriver extends GenericDriver<NamespaceProvider> {

  @Autowired
  private ProviderRepository repository;

  public BocloudResult list(String vendor) {
    NamespaceProvider provider = getProvider(vendor, NamespaceProvider.class, repository);
    if (before(provider).isFailed()) {
      return new BocloudResult(false, "平台认证失败！");
    }
    return provider.list();
  }

  public BocloudResult create(String vendor, NamespaceModel model) {
    NamespaceProvider provider = getProvider(vendor, NamespaceProvider.class, repository);
    if (before(provider).isFailed()) {
      return new BocloudResult(false, "平台认证失败！");
    }
    return provider.create(model);
  }

  public BocloudResult remove(NamespaceModel model, String vendor) {
    NamespaceProvider provider = getProvider(vendor, NamespaceProvider.class, repository);
    if (before(provider).isFailed()) {
      return new BocloudResult(false, "平台认证失败！");
    }
    return provider.remove(model);
  }

  public BocloudResult detail(NamespaceModel model, String vendor) {
    NamespaceProvider provider = getProvider(vendor, NamespaceProvider.class, repository);
    if (before(provider).isFailed()) {
      return new BocloudResult(false, "平台认证失败！");
    }
    return provider.detail(model);
  }

  public BocloudResult modify(String vendor, NamespaceModel model) {
    NamespaceProvider provider = getProvider(vendor, NamespaceProvider.class, repository);
    if (before(provider).isFailed()) {
      return new BocloudResult(false, "平台认证失败！");
    }
    return provider.modify(model);
  }

}
