package com.bocloud.cmp.driver.kubernetes;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.kubernetes.NodeModel;
import com.bocloud.cmp.provider.kubernetes.NodeProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * k8s node
 * 
 * @时间 2019年8月21日
 */
@Service("nodeDriver")
public class NodeDriver extends GenericDriver<NodeProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		NodeProvider provider = getProvider(vendor, NodeProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, NodeModel model) {
		NodeProvider provider = getProvider(vendor, NodeProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(NodeModel model, String vendor) {
		NodeProvider provider = getProvider(vendor, NodeProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult detail(NodeModel model, String vendor) {
		NodeProvider provider = getProvider(vendor, NodeProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.detail(model);
	}

	public BocloudResult modify(String vendor, NodeModel model) {
		NodeProvider provider = getProvider(vendor, NodeProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult modifySchedule(String vendor, NodeModel model) {
		NodeProvider provider = getProvider(vendor, NodeProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modifySchedule(model);
	}

	public BocloudResult removeNodeLabels(String vendor, NodeModel model) {
		NodeProvider provider = getProvider(vendor, NodeProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.removeNodeLabels(model);
	}

	public BocloudResult addNodeLabels(String vendor, NodeModel model) {
		NodeProvider provider = getProvider(vendor, NodeProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.addNodeLabels(model);
	}

}
