package com.bocloud.cmp.driver.kubernetes;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.kubernetes.PersistentVolumeClaimModel;
import com.bocloud.cmp.provider.kubernetes.PersistentVolumeClaimProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * k8s persistentVolumeClaimDriver
 * 
 * @时间 2019年8月21日
 */
@Service("persistentVolumeClaimDriver")
public class PersistentVolumeClaimDriver extends GenericDriver<PersistentVolumeClaimProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		PersistentVolumeClaimProvider provider = getProvider(vendor, PersistentVolumeClaimProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, PersistentVolumeClaimModel model) {
		PersistentVolumeClaimProvider provider = getProvider(vendor, PersistentVolumeClaimProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(PersistentVolumeClaimModel model, String vendor) {
		PersistentVolumeClaimProvider provider = getProvider(vendor, PersistentVolumeClaimProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult detail(PersistentVolumeClaimModel model, String vendor) {
		PersistentVolumeClaimProvider provider = getProvider(vendor, PersistentVolumeClaimProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.detail(model);
	}

	public BocloudResult modify(String vendor, PersistentVolumeClaimModel model) {
		PersistentVolumeClaimProvider provider = getProvider(vendor, PersistentVolumeClaimProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(model);
	}

}
