package com.bocloud.cmp.driver.kubernetes;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.kubernetes.PersistentVolumeModel;
import com.bocloud.cmp.provider.kubernetes.PersistentVolumeProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * k8s PersistentVolume
 * 
 * @时间 2019年8月21日
 */
@Service("persistentVolumeDriver")
public class PersistentVolumeDriver extends GenericDriver<PersistentVolumeProvider> {

  @Autowired
  private ProviderRepository repository;

  public BocloudResult list(String vendor) {
    PersistentVolumeProvider provider = getProvider(vendor, PersistentVolumeProvider.class, repository);
    if (before(provider).isFailed()) {
      return new BocloudResult(false, "平台认证失败！");
    }
    return provider.list();
  }

  public BocloudResult create(String vendor, PersistentVolumeModel model) {
    PersistentVolumeProvider provider = getProvider(vendor, PersistentVolumeProvider.class, repository);
    if (before(provider).isFailed()) {
      return new BocloudResult(false, "平台认证失败！");
    }
    return provider.create(model);
  }

  public BocloudResult remove(PersistentVolumeModel model, String vendor) {
    PersistentVolumeProvider provider = getProvider(vendor, PersistentVolumeProvider.class, repository);
    if (before(provider).isFailed()) {
      return new BocloudResult(false, "平台认证失败！");
    }
    return provider.remove(model);
  }

  public BocloudResult detail(PersistentVolumeModel model, String vendor) {
    PersistentVolumeProvider provider = getProvider(vendor, PersistentVolumeProvider.class, repository);
    if (before(provider).isFailed()) {
      return new BocloudResult(false, "平台认证失败！");
    }
    return provider.detail(model);
  }

  public BocloudResult modify(String vendor, PersistentVolumeModel model) {
    PersistentVolumeProvider provider = getProvider(vendor, PersistentVolumeProvider.class, repository);
    if (before(provider).isFailed()) {
      return new BocloudResult(false, "平台认证失败！");
    }
    return provider.modify(model);
  }

}
