package com.bocloud.cmp.driver.kubernetes;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.kubernetes.PodModel;
import com.bocloud.cmp.provider.kubernetes.PodProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * k8s pod
 * 
 * @时间 2019年8月21日
 */
@Service("podDriver")
public class PodDriver extends GenericDriver<PodProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		PodProvider provider = getProvider(vendor, PodProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, PodModel model) {
		PodProvider provider = getProvider(vendor, PodProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(PodModel model, String vendor) {
		PodProvider provider = getProvider(vendor, PodProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult detail(PodModel model, String vendor) {
		PodProvider provider = getProvider(vendor, PodProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.detail(model);
	}

	public BocloudResult modify(String vendor, PodModel model) {
		PodProvider provider = getProvider(vendor, PodProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult logDetail(String vendor, PodModel model) {
		PodProvider provider = getProvider(vendor, PodProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.logDetail(model);
	}

}
