package com.bocloud.cmp.driver.kubernetes;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.kubernetes.SecretModel;
import com.bocloud.cmp.provider.kubernetes.SecretProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * k8s service
 * 
 * @时间 2019年8月21日
 */
@Service("secretDriver")
public class SecretDriver extends GenericDriver<SecretProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String region) {
		SecretProvider provider = getProvider(vendor, SecretProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, SecretModel model) {
		SecretProvider provider = getProvider(vendor, SecretProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(SecretModel model, String vendor) {
		SecretProvider provider = getProvider(vendor, SecretProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult detail(SecretModel model, String vendor) {
		SecretProvider provider = getProvider(vendor, SecretProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.detail(model);
	}

	public BocloudResult modify(String vendor, SecretModel model) {
		SecretProvider provider = getProvider(vendor, SecretProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(model);
	}

}
