package com.bocloud.cmp.driver.kubernetes;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.kubernetes.ServiceModel;
import com.bocloud.cmp.provider.kubernetes.ServiceProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * k8s service
 * 
 * @时间 2019年8月21日
 */
@Service("serviceDriver")
public class ServiceDriver extends GenericDriver<ServiceProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String region) {
		ServiceProvider provider = getProvider(vendor, ServiceProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, ServiceModel model) {
		ServiceProvider provider = getProvider(vendor, ServiceProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(ServiceModel model, String vendor) {
		ServiceProvider provider = getProvider(vendor, ServiceProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult detail(ServiceModel model, String vendor) {
		ServiceProvider provider = getProvider(vendor, ServiceProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.detail(model);
	}

	public BocloudResult modify(String vendor, ServiceModel model) {
		ServiceProvider provider = getProvider(vendor, ServiceProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(model);
	}

}
