package com.bocloud.cmp.driver.manageone;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.manageone.VdcModel;
import com.bocloud.cmp.provider.manageone.VdcProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * manage one vdc
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年6月15日
 *
 */
@Service("manageOneVdcDriver")
public class VdcDriver extends GenericDriver<VdcProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		VdcProvider provider = getProvider(vendor, VdcProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, VdcModel model) {
		VdcProvider provider = getProvider(vendor, VdcProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult create(String vendor, String username, String password, String projectId, String domainName,
			VdcModel model) {
		VdcProvider provider = getProvider(vendor, username, password, projectId, domainName, VdcProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String managerId) {
		VdcProvider provider = getProvider(vendor, VdcProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.remove(managerId);
	}

	public BocloudResult detail(String vendor, String managerId) {
		VdcProvider provider = getProvider(vendor, VdcProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.detail(managerId);
	}

	public BocloudResult update(String vendor, VdcModel model) {
		VdcProvider provider = getProvider(vendor, VdcProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.update(model);
	}
}
