package com.bocloud.cmp.driver.manageone;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.manageone.VdcProjectModel;
import com.bocloud.cmp.provider.manageone.VdcProjectProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * manage one项目
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年6月15日
 *
 */
@Service("vdcProjectDriver")
public class VdcProjectDriver extends GenericDriver<VdcProjectProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String vdcId) {
		VdcProjectProvider provider = getProvider(vendor, VdcProjectProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list(vdcId);
	}

	public BocloudResult create(String vendor, VdcProjectModel model) {
		VdcProjectProvider provider = getProvider(vendor, VdcProjectProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult create(String vendor, String username, String password, String projectId, String domainName,
			VdcProjectModel model) {
		VdcProjectProvider provider = getProvider(vendor, username, password, projectId, domainName,
				VdcProjectProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String projectId) {
		VdcProjectProvider provider = getProvider(vendor, VdcProjectProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.remove(projectId);
	}

	public BocloudResult detail(String vendor, String projectId) {
		VdcProjectProvider provider = getProvider(vendor, VdcProjectProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.detail(projectId);
	}

	public BocloudResult update(String vendor, VdcProjectModel model) {
		VdcProjectProvider provider = getProvider(vendor, VdcProjectProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.update(model);
	}
}
