package com.bocloud.cmp.driver.manageone;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.manageone.VdcUserModel;
import com.bocloud.cmp.provider.manageone.VdcUserProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * manage one用户
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年6月15日
 *
 */
@Service("vdcUserDriver")
public class VdcUserDriver extends GenericDriver<VdcUserProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String tenantId) {
		VdcUserProvider provider = getProvider(vendor, VdcUserProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list(tenantId);
	}

	public BocloudResult create(String vendor, VdcUserModel model) {
		VdcUserProvider provider = getProvider(vendor, VdcUserProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult create(String vendor, String username, String password, String projectId, String domainName,
			VdcUserModel model) {
		VdcUserProvider provider = getProvider(vendor, username, password, projectId, domainName, VdcUserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String userId) {
		VdcUserProvider provider = getProvider(vendor, VdcUserProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.remove(userId);
	}

	public BocloudResult detail(String vendor, String userId) {
		VdcUserProvider provider = getProvider(vendor, VdcUserProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.detail(userId);
	}

}
