package com.bocloud.cmp.driver.monitor;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.AlarmModel;
import com.bocloud.cmp.provider.monitor.AlarmProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * 告警操作服务接口实现类
 * 
 * @author weiwei
 *
 */
@Service("alarmDriver")
public class AlarmDriver extends GenericDriver<AlarmProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String region) {
		AlarmProvider provider = getProvider(vendor, AlarmProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.sync();
	}

	public BocloudResult create(AlarmModel alarmModel, String vendor, String region) {
		AlarmProvider provider = getProvider(vendor, AlarmProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(alarmModel);
	}

	public BocloudResult update(AlarmModel alarmModel, String vendor, String region) {
		AlarmProvider provider = getProvider(vendor, AlarmProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.update(alarmModel);
	}

	public BocloudResult confirm(AlarmModel alarmModel, String vendor, String region) {
		AlarmProvider provider = getProvider(vendor, AlarmProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.confirm(alarmModel);
	}
}
