package com.bocloud.cmp.driver.monitor;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.monitor.MetricAlertModel;
import com.bocloud.cmp.provider.monitor.MetricAlertProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: MetricAlertDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2020/12/29 16:36
 */
@Service("metricAlertDriver")
public class MetricAlertDriver extends GenericDriver<MetricAlertProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor, String region) {
        MetricAlertProvider provider = getProvider(vendor, MetricAlertProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult create(String vendor, String region, MetricAlertModel model) {
        MetricAlertProvider provider = getProvider(vendor, MetricAlertProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.create(model);
    }


    public BocloudResult remove(String vendor, String region, MetricAlertModel model) {
        MetricAlertProvider provider = getProvider(vendor, MetricAlertProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.remove(model);
    }

    public BocloudResult modify(String vendor, String region, MetricAlertModel model) {
        MetricAlertProvider provider = getProvider(vendor, MetricAlertProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "云平台认证失败！");
        }
        return provider.modify(model);
    }

}