package com.bocloud.cmp.driver.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.LbListenerModel;
import com.bocloud.cmp.provider.network.ListenerProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * AWS侦听器实现类
 *
 * @author
 */
@Service("listenerDriver")
public class ListenerDriver extends GenericDriver<ListenerProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(LbListenerModel model, String vendor, String region) {
        ListenerProvider provider = getProvider(vendor, ListenerProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String uuid, String vendor, String region) {
        ListenerProvider provider = getProvider(vendor, ListenerProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.delete(uuid);
    }
}
