package com.bocloud.cmp.driver.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.NatGatewayDnatRuleModel;
import com.bocloud.cmp.provider.network.NatGatewayDnatRuleProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 华为云nat网关dnat规则
 *
 * @author
 */
@Service("natGatewayDnatRuleDriver")
public class NatGatewayDnatRuleDriver extends GenericDriver<NatGatewayDnatRuleProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String region) {
		
		NatGatewayDnatRuleProvider provider = getProvider(vendor, NatGatewayDnatRuleProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult remove(String vendor, String natGatewayId, String dnatRuleId, String region) {
		NatGatewayDnatRuleProvider provider = getProvider(vendor, NatGatewayDnatRuleProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(natGatewayId, dnatRuleId);

	}

	public BocloudResult update(NatGatewayDnatRuleModel model, String vendor, String region) {
		NatGatewayDnatRuleProvider provider = getProvider(vendor, NatGatewayDnatRuleProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult create(NatGatewayDnatRuleModel model, String vendor, String region) {
		NatGatewayDnatRuleProvider provider = getProvider(vendor, NatGatewayDnatRuleProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}
}
