package com.bocloud.cmp.driver.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.NatGatewayModel;
import com.bocloud.cmp.provider.network.NatGatewayProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 华为云nat网关
 *
 * @author
 */
@Service("natGatewayDriver")
public class NatGatewayDriver extends GenericDriver<NatGatewayProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor, String region) {
        NatGatewayProvider provider = getProvider(vendor, NatGatewayProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult detail(String natGatewayId, String vendor, String region) {
        NatGatewayProvider provider = getProvider(vendor, NatGatewayProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.detail(natGatewayId);
    }

    public BocloudResult remove(String vendor, String natGatewayId, String region) {
        NatGatewayProvider provider = getProvider(vendor, NatGatewayProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(natGatewayId);
    }

    public BocloudResult remove(String vendor, String region, String natGatewayId, Boolean force) {
        NatGatewayProvider provider = getProvider(vendor, NatGatewayProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(natGatewayId, force);

    }

    public BocloudResult update(NatGatewayModel model, String vendor, String region) {
        NatGatewayProvider provider = getProvider(vendor, NatGatewayProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult create(NatGatewayModel model, String vendor, String region) {
        NatGatewayProvider provider = getProvider(vendor, NatGatewayProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }
}
