package com.bocloud.cmp.driver.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.NatGatewayDnatRuleModel;
import com.bocloud.cmp.model.NatGatewaySnatRuleModel;
import com.bocloud.cmp.provider.network.NatGatewayDnatRuleProvider;
import com.bocloud.cmp.provider.network.NatGatewaySnatRuleProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 华为云nat网关snat规则
 *
 * @author
 */
@Service("natGatewaySnatRuleDriver")
public class NatGatewaySnatRuleDriver extends GenericDriver<NatGatewaySnatRuleProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String region) {
		NatGatewaySnatRuleProvider provider = getProvider(vendor, NatGatewaySnatRuleProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}


	public BocloudResult remove(String vendor, String natGatewayId, String snatRuleId, String region) {
		NatGatewaySnatRuleProvider provider = getProvider(vendor, NatGatewaySnatRuleProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(natGatewayId, snatRuleId);

	}

	public BocloudResult update(NatGatewaySnatRuleModel model, String vendor, String region) {
		NatGatewaySnatRuleProvider provider = getProvider(vendor, NatGatewaySnatRuleProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult create(NatGatewaySnatRuleModel model, String vendor, String region) {
		NatGatewaySnatRuleProvider provider = getProvider(vendor, NatGatewaySnatRuleProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}
}
