package com.bocloud.cmp.driver.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.PortModel;
import com.bocloud.cmp.provider.network.PortProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("portDriver")
public class PortDriver extends GenericDriver<PortProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, String region, PortModel portModel) {
        PortProvider provider = getProvider(vendor, PortProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(portModel);
    }

    public BocloudResult create(String vendor, String projectName, String region, PortModel portModel) {
        PortProvider provider = getProvider(vendor, projectName, PortProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(portModel);
    }


    public BocloudResult remove(String portId, String vendor, String region) {
        PortProvider provider = getProvider(vendor, PortProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(portId);
    }


    public BocloudResult detail(String portId, String vendor, String region) {
        PortProvider provider = getProvider(vendor, PortProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.detail(portId);
    }


    public BocloudResult modify(String vendor, String region, PortModel portModel) {
        PortProvider provider = getProvider(vendor, PortProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(portModel);
    }

    public BocloudResult sync(String vendor, String region) {
        PortProvider provider = getProvider(vendor, PortProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.sync();
    }
}
