package com.bocloud.cmp.driver.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.PortGroupModel;
import com.bocloud.cmp.provider.network.PortGroupProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Company: 博云 www.bocloud.com
 * @ClassName: PortGroupDriver
 * @Description:
 * @author: zhenpingLi/李振平
 * @date: 2021/10/26 15:03
 */
@Service
public class PortGroupDriver extends GenericDriver<PortGroupProvider> {
    @Autowired
    private ProviderRepository repository;


    public BocloudResult create(String vendor, String region, PortGroupModel group) {
        PortGroupProvider provider = getProvider(vendor, PortGroupProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(group);
    }

    public BocloudResult modify(String vendor, String region, PortGroupModel group) {
        PortGroupProvider provider = getProvider(vendor, PortGroupProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(group);
    }

    public BocloudResult remove(String vendor, String region, String uuid) {
        PortGroupProvider provider = getProvider(vendor, PortGroupProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(uuid);
    }
}