package com.bocloud.cmp.driver.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.azure.PublicIPAddressModel;
import com.bocloud.cmp.provider.network.PublicIPAddressProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName: PublicIPAddressDriver
 * @Description:
 * @author: zhenpingLi/李振平
 */
@Service("publicIPAddressDriver")
public class PublicIPAddressDriver extends GenericDriver<PublicIPAddressProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult create(String vendor, String region, PublicIPAddressModel model) {
        PublicIPAddressProvider provider = getProvider(vendor, PublicIPAddressProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(String vendor, String region, PublicIPAddressModel model) {
        PublicIPAddressProvider provider = getProvider(vendor, PublicIPAddressProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.modify(model);
    }


    public BocloudResult remove(String vendor, String region, String uuid) {
        PublicIPAddressProvider provider = getProvider(vendor, PublicIPAddressProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.remove(uuid);
    }

    public BocloudResult detail(String vendor, String region, String uuid) {
        PublicIPAddressProvider provider = getProvider(vendor, PublicIPAddressProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.detail(uuid);
    }

}