package com.bocloud.cmp.driver.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.RouteModel;
import com.bocloud.cmp.provider.network.RouteProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * AWSRoute实现类
 *
 * @author
 */
@Service("routeDriver")
public class RouteDriver extends GenericDriver<RouteProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult create(RouteModel model, String vendor, String region) {
		RouteProvider provider = getProvider(vendor, RouteProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult delete(RouteModel model, String vendor, String region) {
		RouteProvider provider = getProvider(vendor, RouteProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.delete(model);
	}

	public BocloudResult update(RouteModel model, String vendor, String region) {
		RouteProvider provider = getProvider(vendor, RouteProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(model);
	}

}
