package com.bocloud.cmp.driver.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.network.RouteTableAssociationProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * AWSRouteTableAssociation实现类
 *
 * @author
 */
@Service("routeTableAssociation")
public class RouteTableAssociationDriver extends GenericDriver<RouteTableAssociationProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult replaceAssociation(String routeTableId, String associationId, String vendor, String region) {
        RouteTableAssociationProvider provider = getProvider(vendor, RouteTableAssociationProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.replaceAssociation(routeTableId, associationId);
    }

    public BocloudResult associateRouteTable(String routeTableId, String gatewayId, String subnetId, String vendor, String region) {
        RouteTableAssociationProvider provider = getProvider(vendor, RouteTableAssociationProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.associateRouteTable(routeTableId, gatewayId, subnetId);
    }

    public BocloudResult disassociateRouteTable(String associationId, String vendor, String region) {
        RouteTableAssociationProvider provider = getProvider(vendor, RouteTableAssociationProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败！");
        }
        return provider.disassociateRouteTable(associationId);
    }
}
