package com.bocloud.cmp.driver.network;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.RouterModel;
import com.bocloud.cmp.provider.network.RouterProvider;
import com.bocloud.common.model.BocloudResult;

@Service("routerDriver")
public class RouterDriver extends GenericDriver<RouterProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult create(RouterModel model, String vendor, String region) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult create(RouterModel model, String vendor, String projectName, String region) {
		RouterProvider provider = getProvider(vendor, projectName, RouterProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult create(RouterModel model, String vendor, String username, String password, String projectId,
			String domainName) {
		RouterProvider provider = getProvider(vendor, username, password, projectId, domainName, RouterProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult modify(RouterModel model, String vendor, String region) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult modify(RouterModel model, String vendor, String username, String password, String projectId,
			String domainName) {
		RouterProvider provider = getProvider(vendor, username, password, projectId, domainName, RouterProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult remove(String routerId, String vendor, String region) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(routerId);
	}

	public BocloudResult remove(String routerId, String vendor, String username, String password, String projectId,
			String domainName) {
		RouterProvider provider = getProvider(vendor, username, password, projectId, domainName, RouterProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(routerId);
	}

	public BocloudResult detail(String routerId, String vendor, String region) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.detail(routerId);
	}

	public BocloudResult attach(RouterModel model, String vendor, String region) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.attach(model);
	}

	public BocloudResult attach(RouterModel model, String vendor, String username, String password, String projectId,
			String domainName) {
		RouterProvider provider = getProvider(vendor, username, password, projectId, domainName, RouterProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.attach(model);
	}

	public BocloudResult detach(RouterModel model, String vendor, String region) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.detach(model);
	}

	public BocloudResult detach(RouterModel model, String vendor, String username, String password, String projectId,
			String domainName) {
		RouterProvider provider = getProvider(vendor, username, password, projectId, domainName, RouterProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.detach(model);
	}

	public BocloudResult config(RouterModel model, String vendor, String region) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.config(model);
	}

	public BocloudResult config(RouterModel model, String vendor, String username, String password, String projectId,
			String domainName) {
		RouterProvider provider = getProvider(vendor, username, password, projectId, domainName, RouterProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.config(model);
	}

	public BocloudResult clear(String routerId, String vendor, String region) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.clear(routerId);
	}

	public BocloudResult clear(String routerId, String vendor, String username, String password, String projectId,
			String domainName) {
		RouterProvider provider = getProvider(vendor, username, password, projectId, domainName, RouterProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.clear(routerId);
	}

	public BocloudResult remove(RouterModel model, String vendor, String region) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(model);
	}
}