package com.bocloud.cmp.driver.network;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.SwitchModel;
import com.bocloud.cmp.provider.network.SwitchProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("switchDriver")
public class SwitchDriver extends GenericDriver<SwitchProvider> {
	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String region) {
		SwitchProvider provider = getProvider(vendor, SwitchProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, String region, SwitchModel switchModel) {
		SwitchProvider provider = getProvider(vendor, SwitchProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(switchModel);
	}

	public BocloudResult modify(String vendor, String region, SwitchModel switchModel) {
		SwitchProvider provider = getProvider(vendor, SwitchProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.modify(switchModel);
	}

	public BocloudResult remove(String vendor, String region, SwitchModel switchModel) {
		SwitchProvider provider = getProvider(vendor, SwitchProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(switchModel);
	}

	public BocloudResult remove(String vendor, String region, String uri) {
		SwitchProvider provider = getProvider(vendor, SwitchProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(uri);
	}

	public BocloudResult addUpLink(String vendor, String region, SwitchModel switchModel) {
		SwitchProvider provider = getProvider(vendor, SwitchProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.addUpLink(switchModel);
	}

	public BocloudResult removeUpLink(String vendor, String region, SwitchModel switchModel) {
		SwitchProvider provider = getProvider(vendor, SwitchProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.removeUpLink(switchModel);
	}

	public BocloudResult addVlanPool(String vendor, String region, SwitchModel switchModel) {
		SwitchProvider provider = getProvider(vendor, SwitchProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.addVlanPool(switchModel);
	}

	public BocloudResult removeVlanPool(String vendor, String region, SwitchModel switchModel) {
		SwitchProvider provider = getProvider(vendor, SwitchProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.removeVlanPool(switchModel);
	}
}
