package com.bocloud.cmp.driver.network;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.TagModel;
import com.bocloud.cmp.provider.network.TagProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * AWSTag实现类
 *
 * @author
 */
@Service("tagDriver")
public class TagDriver extends GenericDriver<TagProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String region) {
		TagProvider provider = getProvider(vendor, TagProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, List<TagModel> models, String region) {
		TagProvider provider = getProvider(vendor, TagProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(models);
	}

	public BocloudResult remove(String vendor, List<TagModel> models, String region) {
		TagProvider provider = getProvider(vendor, TagProvider.class, repository, region);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(models);
	}

}
