package com.bocloud.cmp.driver.nsx;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.nsx.FirewallRuleProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.nsx.NsxFirewallRuleModel;

/**
 * nsx防火墙规则
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年2月24日
 *
 */
@Service("firewallRuleDriver")
public class FirewallRuleDriver extends GenericDriver<FirewallRuleProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor, String firewallId) {
		FirewallRuleProvider provider = getProvider(vendor, FirewallRuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list(firewallId);
	}

	public BocloudResult update(String vendor, List<NsxFirewallRuleModel> ruleModels, String firewallId) {
		FirewallRuleProvider provider = getProvider(vendor, FirewallRuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.update(ruleModels, firewallId);
	}
}
