package com.bocloud.cmp.driver.nsx;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.nsx.NsGroupProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.nsx.NsxNSGroupModel;

/**
 * nsx组
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年2月24日
 *
 */
@Service("nsGroupDriver")
public class NsGroupDriver extends GenericDriver<NsGroupProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		NsGroupProvider provider = getProvider(vendor, NsGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, NsxNSGroupModel model) {
		NsGroupProvider provider = getProvider(vendor, NsGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String portId) {
		NsGroupProvider provider = getProvider(vendor, NsGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.remove(portId);
	}

	public BocloudResult detail(String vendor, String groupId) {
		NsGroupProvider provider = getProvider(vendor, NsGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.detail(groupId);
	}

	public BocloudResult update(String vendor, NsxNSGroupModel model) {
		NsGroupProvider provider = getProvider(vendor, NsGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.update(model);
	}
}
