package com.bocloud.cmp.driver.nsx;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.nsx.RouterProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.nsx.NsxLogicalRouterModel;
import com.bocloud.nms.model.nsx.NsxTierOneModel;
import com.bocloud.nms.model.nsx.NsxTierZeroModel;

@Service("logicalRouterDriver")
public class RouterDriver extends GenericDriver<RouterProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult listTier0(String vendor) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.listTier0();
	}

	public BocloudResult createTier0(String vendor, NsxTierZeroModel model) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.createTier0(model);
	}

	public BocloudResult removeTier0(String vendor, String tier0Id) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.removeTier0(tier0Id);
	}

	public BocloudResult detailTier0(String vendor, String tier0Id) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.detailTier0(tier0Id);
	}

	public BocloudResult updateTier0(String vendor, NsxTierZeroModel model) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.updateTier0(model);
	}

	public BocloudResult listTier1(String vendor) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.listTier1();
	}

	public BocloudResult createTier1(String vendor, NsxTierOneModel model) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.createTier1(model);
	}

	public BocloudResult removeTier1(String vendor, String tier1Id) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.removeTier1(tier1Id);
	}

	public BocloudResult detailTier1(String vendor, String tier1Id) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.detailTier1(tier1Id);
	}

	public BocloudResult updateTier1(String vendor, NsxTierOneModel model) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.updateTier1(model);
	}

	public BocloudResult list(String vendor) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, NsxLogicalRouterModel model) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String routerId) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.remove(routerId);
	}

	public BocloudResult detail(String vendor, String routerId) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.detail(routerId);
	}

	public BocloudResult update(String vendor, NsxLogicalRouterModel model) {
		RouterProvider provider = getProvider(vendor, RouterProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.update(model);
	}
}
