package com.bocloud.cmp.driver.nsx;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.nsx.SegmentProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.nsx.NsxSegmentModel;

@Service("segmentDriver")
public class SegmentDriver extends GenericDriver<SegmentProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		SegmentProvider provider = getProvider(vendor, SegmentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, NsxSegmentModel model) {
		SegmentProvider provider = getProvider(vendor, SegmentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String segmentId) {
		SegmentProvider provider = getProvider(vendor, SegmentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.remove(segmentId);
	}

	public BocloudResult detail(String vendor, String segmentId) {
		SegmentProvider provider = getProvider(vendor, SegmentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.detail(segmentId);
	}

	public BocloudResult update(String vendor, NsxSegmentModel model) {
		SegmentProvider provider = getProvider(vendor, SegmentProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.update(model);
	}
}
