package com.bocloud.cmp.driver.pbm;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.pbm.PbmProfileProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * vcenter存储策略
 * 
 * @author wangyu
 * @version 1.0
 * @since 2020年6月15日
 *
 */
@Service("pbmProfileDriver")
public class PbmProfileDriver extends GenericDriver<PbmProfileProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		PbmProfileProvider provider = getProvider(vendor, PbmProfileProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.list();
	}
}
