package com.bocloud.cmp.driver.sdn;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.cisco.BridgeDomainModel;
import com.bocloud.cmp.provider.network.BDProvider;
import com.bocloud.common.model.BocloudResult;

@Service("bDDriver")
public class BdDriver extends GenericDriver<BDProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult create(String vendor, BridgeDomainModel model) {
		BDProvider provider = getProvider(vendor, BDProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String dn) {
		BDProvider provider = getProvider(vendor, BDProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(dn);
	}

}
