package com.bocloud.cmp.driver.sdn;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.cisco.ContractModel;
import com.bocloud.cmp.provider.network.ContractProvider;
import com.bocloud.common.model.BocloudResult;

@Service("contractDriver")
public class ContractDriver extends GenericDriver<ContractProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult create(String vendor, ContractModel model) {
		ContractProvider provider = getProvider(vendor, ContractProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String dn) {
		ContractProvider provider = getProvider(vendor, ContractProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(dn);
	}

}
