package com.bocloud.cmp.driver.sdn;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.network.HealthProvider;
import com.bocloud.common.model.BocloudResult;

@Service("healthDriver")
public class HealthDriver extends GenericDriver<HealthProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult healths(String vendor, int type) {
		HealthProvider provider = getProvider(vendor, HealthProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.getHealths(type);
	}

	public BocloudResult nodes(String vendor) {
		HealthProvider provider = getProvider(vendor, HealthProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.getNodes();
	}

	public BocloudResult tenants(String vendor) {
		HealthProvider provider = getProvider(vendor, HealthProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.getTenants();
	}
}
