package com.bocloud.cmp.driver.sdn;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.cisco.ProfileModel;
import com.bocloud.cmp.provider.network.ProfileProvider;
import com.bocloud.common.model.BocloudResult;

@Service("profileDriver")
public class ProfileDriver extends GenericDriver<ProfileProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult create(String vendor, ProfileModel model) {
		ProfileProvider provider = getProvider(vendor, ProfileProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String dn) {
		ProfileProvider provider = getProvider(vendor, ProfileProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(dn);
	}

}
