package com.bocloud.cmp.driver.sdn;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.cisco.SubjectModel;
import com.bocloud.cmp.provider.network.SubjectProvider;
import com.bocloud.common.model.BocloudResult;

@Service("subjectDriver")
public class SubjectDriver extends GenericDriver<SubjectProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult create(String vendor, SubjectModel model) {
		SubjectProvider provider = getProvider(vendor, SubjectProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String dn) {
		SubjectProvider provider = getProvider(vendor, SubjectProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(dn);
	}

}
