package com.bocloud.cmp.driver.sdn;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.cisco.VrfModel;
import com.bocloud.cmp.provider.network.VrfProvider;
import com.bocloud.common.model.BocloudResult;

@Service("vrfDriver")
public class VrfDriver extends GenericDriver<VrfProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult create(String vendor, VrfModel model) {
		VrfProvider provider = getProvider(vendor, VrfProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(String vendor, String dn) {
		VrfProvider provider = getProvider(vendor, VrfProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "平台认证失败！");
		}
		return provider.remove(dn);
	}

}
