package com.bocloud.cmp.driver.secuirty;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.sangfor.SangforFirewallRuleModel;
import com.bocloud.cmp.provider.security.FirewallRuleProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("sangforFirewallRuleDriver")
public class SangforFirewallRuleDriver extends GenericDriver<FirewallRuleProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		FirewallRuleProvider provider = getProvider(vendor, FirewallRuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, SangforFirewallRuleModel firewallRuleModel) {
		FirewallRuleProvider provider = getProvider(vendor, FirewallRuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.create(firewallRuleModel);
	}

	public BocloudResult updateRule(String vendor, SangforFirewallRuleModel firewallRuleModel) {
		FirewallRuleProvider provider = getProvider(vendor, FirewallRuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.updateRule(firewallRuleModel);
	}

	public BocloudResult remove(String vendor, String firewallRuleId) {
		FirewallRuleProvider provider = getProvider(vendor, FirewallRuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.remove(firewallRuleId);
	}

	public BocloudResult getIpgps(String vendor, String query) {
		FirewallRuleProvider provider = getProvider(vendor, FirewallRuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.getIpgps(query);
	}

	public BocloudResult getServiceDefaults(String vendor, String query_srv) {
		FirewallRuleProvider provider = getProvider(vendor, FirewallRuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.serviceDefault(query_srv);
	}

	public BocloudResult getServiceCustom(String vendor) {
		FirewallRuleProvider provider = getProvider(vendor, FirewallRuleProvider.class, repository);
		if (before(provider).isFailed()) {
			return new BocloudResult(false, "云平台认证失败！");
		}
		return provider.serviceCustomdefault();
	}
}
