package com.bocloud.cmp.driver.secuirty;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.Butler;
import com.bocloud.cmp.model.UserModel;
import com.bocloud.cmp.provider.security.UserProvider;
import com.bocloud.common.model.BocloudResult;

@Service("userDriver")
public class UserDriver extends GenericDriver<UserProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(UserModel model, String vendor) {
		UserProvider provider = getProvider(vendor, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.list(model);
	}

	public BocloudResult create(UserModel model, String vendor) {
		UserProvider provider = getProvider(vendor, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult update(UserModel model, String vendor) {
		UserProvider provider = getProvider(vendor, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.update(model);
	}

	public BocloudResult lock(UserModel model, String vendor) {
		UserProvider provider = getProvider(vendor, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.lock(model);
	}

	public BocloudResult remove(UserModel model, String vendor) {
		UserProvider provider = getProvider(vendor, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult listKey(Long userId, String vendor) {
		UserProvider provider = getProvider(vendor, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.listKey(userId);
	}

	public BocloudResult hasChild(Long userId, String vendor) {
		UserProvider provider = getProvider(vendor, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.hasChild(userId);
	}

	public BocloudResult create(UserModel model, Butler butler) {
		UserProvider provider = getProvider(butler, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult update(UserModel model, Butler butler) {
		UserProvider provider = getProvider(butler, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.update(model);
	}

	public BocloudResult remove(UserModel model, Butler butler) {
		UserProvider provider = getProvider(butler, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult listKey(Long userId, Butler butler) {
		UserProvider provider = getProvider(butler, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.listKey(userId);
	}

	public BocloudResult hasChild(Long userId, Butler butler) {
		UserProvider provider = getProvider(butler, UserProvider.class,
				repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.hasChild(userId);
	}
}
