package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.AccessPathModel;
import com.bocloud.cmp.provider.storage.AccessPathProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("accessPathDriver")
public class AccessPathDriver extends GenericDriver<AccessPathProvider> {
    @Autowired
    private ProviderRepository repository;


    public BocloudResult create(String vendor, AccessPathModel model) {
        AccessPathProvider provider = getProvider(vendor, AccessPathProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(String vendor, AccessPathModel model) {
        AccessPathProvider provider = getProvider(vendor, AccessPathProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult remove(String vendor, String pathUuid) {
        AccessPathProvider provider = getProvider(vendor, AccessPathProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(pathUuid);
    }

}
