package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.TargetModel;
import com.bocloud.cmp.provider.storage.AccessPathGatewayProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("accessPathGatewayDriver")
public class AccessPathGatewayDriver extends GenericDriver<AccessPathGatewayProvider> {
    @Autowired
    private ProviderRepository repository;


    public BocloudResult attachHost(String vendor, TargetModel model) {
        AccessPathGatewayProvider provider = getProvider(vendor, AccessPathGatewayProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.attachHost(model);
    }

    public BocloudResult detachHost(String vendor, String targetUuid) {
        AccessPathGatewayProvider provider = getProvider(vendor, AccessPathGatewayProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detachHost(targetUuid);
    }


}
