package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.storage.CapacityProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Scp查询容量接口实现类
 *
 * @author weiwei
 */
@Service("capacityDriver")
public class CapacityDriver extends GenericDriver<CapacityProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult application(String vendor) {
        CapacityProvider provider = getProvider(vendor, CapacityProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.getApplication();
    }


    public BocloudResult storage(String vendor) {
        CapacityProvider provider = getProvider(vendor, CapacityProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.getStorage();
    }


    public BocloudResult resourcePool(String vendor) {
        CapacityProvider provider = getProvider(vendor, CapacityProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.getResourcePool();
    }
}