package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.SanOrderModel;
import com.bocloud.cmp.provider.storage.CatalogProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Scp查询存储对象接口实现类
 *
 * @author weiwei
 */
@Service("scpCatalogProvider")
public class CatalogDriver extends GenericDriver<CatalogProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult createSanOrder(String vendor, SanOrderModel model) {
        CatalogProvider provider = getProvider(vendor, CatalogProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.createSanOrder(model);
    }
}
