package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.DataStoreModel;
import com.bocloud.cmp.provider.storage.DataStoreProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 数据存储操作类
 *
 * @author wangyu
 * @version 1.0
 * @since 2017年12月12日
 */
@Service("dataStoreDriver")
public class DataStoreDriver extends GenericDriver<DataStoreProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult uploadFile(String dcName, String dsName, String filePath, String vendor, String region) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.uploadFile(dcName, dsName, filePath);
    }


    public BocloudResult create(DataStoreModel model, String vendor, String region) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }


    public BocloudResult rename(String dcName, String oldName, String newName, String vendor, String region) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.rename(dcName, oldName, newName);
    }


    public BocloudResult unmount(String dcName, String hostName, String name, String vendor, String region) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.unmount(dcName, hostName, name);
    }


    public BocloudResult remove(String dcName, String name, String vendor, String region) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(dcName, name);
    }

    public BocloudResult detail(String dcName, String dsName, String vendor) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(dcName, dsName);
    }

    public BocloudResult simpleDetail(String dcName, String dsName, String vendor) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.simpleDetail(dcName, dsName);
    }

    public BocloudResult listByVdc(String vendor, String vdcName) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.listByVdc(vdcName);
    }

    public BocloudResult create(String vendor,DataStoreModel model) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(String vendor,DataStoreModel model) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult remove(String vendor, String uuid) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(uuid);
    }

    public BocloudResult listFile(String vendor, String uuid) {
        DataStoreProvider provider = getProvider(vendor, DataStoreProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.listFile(uuid);
    }
}
