package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.storage.StorageDiskModel;
import com.bocloud.cmp.provider.storage.DiskProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("diskDriver")
public class DiskDriver extends GenericDriver<DiskProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor, String region) {
        DiskProvider provider = getProvider(vendor, DiskProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult listByMdisk(String vendor, String mdiskUuid) {
        DiskProvider provider = getProvider(vendor, DiskProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.listByMdisk(mdiskUuid);
    }

    public BocloudResult listByStorage(String vendor, String storageUuid) {
        DiskProvider provider = getProvider(vendor, DiskProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.listByStorage(storageUuid);
    }

    public BocloudResult modify(String vendor, StorageDiskModel model) {
        DiskProvider provider = getProvider(vendor, DiskProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modify(model);
    }
}
