package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.SanFabricModel;
import com.bocloud.cmp.provider.storage.FabricProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 光纤交换机操作类
 *
 * @author lkx007
 */
@Service("fabricDriver")
public class FabricDriver extends GenericDriver<FabricProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        FabricProvider provider = getProvider(vendor, FabricProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult create(String vendor, SanFabricModel model) {
        FabricProvider provider = getProvider(vendor, FabricProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(String vendor, SanFabricModel model) {
        FabricProvider provider = getProvider(vendor, FabricProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult remove(String vendor, String name) {
        FabricProvider provider = getProvider(vendor, FabricProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(name);
    }

    public BocloudResult detail(String vendor, String host) {
        FabricProvider provider = getProvider(vendor, FabricProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(host);
    }
}
