package com.bocloud.cmp.driver.storage;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.xsky.FileClientGroupModel;
import com.bocloud.cmp.model.xsky.FileClientModel;
import com.bocloud.cmp.provider.storage.FileClientProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * xsky 文件用户
 * 
 * @author admin
 *
 */
@Service("fileClientDriver")
public class FileClientDriver extends GenericDriver<FileClientProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult update(FileClientModel fileClientModel, String vendor) {
		FileClientProvider provider = getProvider(vendor, FileClientProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.update(fileClientModel);
	}

	public BocloudResult list(String vendor) {
		FileClientProvider provider = getProvider(vendor, FileClientProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult remove(String uuid, String vendor) {
		FileClientProvider provider = getProvider(vendor, FileClientProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(uuid);
	}

	public BocloudResult create(FileClientModel fileClientModel, String vendor) {
		FileClientProvider provider = getProvider(vendor, FileClientProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(fileClientModel);
	}

	public BocloudResult listClientGroup(String vendor) {
		FileClientProvider provider = getProvider(vendor, FileClientProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.listClientGroup();
	}

	public BocloudResult createClientGroup(FileClientGroupModel fileClientGroupModel, String vendor) {
		FileClientProvider provider = getProvider(vendor, FileClientProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.createClientGroup(fileClientGroupModel);
	}

	public BocloudResult modifyClientGroup(FileClientGroupModel fileClientGroupModel, String vendor) {
		FileClientProvider provider = getProvider(vendor, FileClientProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.modifyClientGroup(fileClientGroupModel);
	}

	public BocloudResult removeClientGroup(String uuid, String vendor) {
		FileClientProvider provider = getProvider(vendor, FileClientProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.removeClientGroup(uuid);
	}

	public BocloudResult removeClients(FileClientGroupModel fileClientGroupModel, String vendor) {
		FileClientProvider provider = getProvider(vendor, FileClientProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.removeClients(fileClientGroupModel);
	}

	public BocloudResult addClients(FileClientGroupModel fileClientGroupModel, String vendor) {
		FileClientProvider provider = getProvider(vendor, FileClientProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.addClients(fileClientGroupModel);
	}

}
