package com.bocloud.cmp.driver.storage;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.xsky.FileGatewayGroupModel;
import com.bocloud.cmp.provider.storage.FileGatewayGroupProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * xsky 文件用户
 * 
 * @author admin
 *
 */
@Service("fileGatewayGroupDriver")
public class FileGatewayGroupDriver extends GenericDriver<FileGatewayGroupProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult modify(FileGatewayGroupModel fileGatewayGroupModel, String vendor) {
		FileGatewayGroupProvider provider = getProvider(vendor, FileGatewayGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.modify(fileGatewayGroupModel);
	}

	public BocloudResult addFSGateways(FileGatewayGroupModel fileGatewayGroupModel, String vendor) {
		FileGatewayGroupProvider provider = getProvider(vendor, FileGatewayGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.addFSGateways(fileGatewayGroupModel);
	}

	public BocloudResult removeFSGateways(FileGatewayGroupModel fileGatewayGroupModel, String vendor) {
		FileGatewayGroupProvider provider = getProvider(vendor, FileGatewayGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.removeFSGateways(fileGatewayGroupModel);
	}

	public BocloudResult list(String vendor) {
		FileGatewayGroupProvider provider = getProvider(vendor, FileGatewayGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult remove(String uuid, String vendor) {
		FileGatewayGroupProvider provider = getProvider(vendor, FileGatewayGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(uuid);
	}

	public BocloudResult create(FileGatewayGroupModel model, String vendor) {
		FileGatewayGroupProvider provider = getProvider(vendor, FileGatewayGroupProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(model);
	}

}
