package com.bocloud.cmp.driver.storage;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.xsky.FileSnapshotModel;
import com.bocloud.cmp.model.xsky.FileSystemModel;
import com.bocloud.cmp.provider.storage.FileSystemProvider;
import com.bocloud.common.model.BocloudResult;

/**
 * xsky 文件用户
 * 
 * @author admin
 *
 */
@Service("fileSystemDriver")
public class FileSystemDriver extends GenericDriver<FileSystemProvider> {

	@Autowired
	private ProviderRepository repository;

	public BocloudResult update(FileSystemModel fileSystemModel, String vendor) {
		FileSystemProvider provider = getProvider(vendor, FileSystemProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.update(fileSystemModel);
	}

	public BocloudResult list(String vendor) {
		FileSystemProvider provider = getProvider(vendor, FileSystemProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult remove(String fileSystemUuid, String vendor) {
		FileSystemProvider provider = getProvider(vendor, FileSystemProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(fileSystemUuid);
	}

	public BocloudResult create(FileSystemModel fileSystemModel, String vendor) {
		FileSystemProvider provider = getProvider(vendor, FileSystemProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(fileSystemModel);
	}

	public BocloudResult listSnapshot(FileSnapshotModel model, String vendor) {
		FileSystemProvider provider = getProvider(vendor, FileSystemProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.listSnapshot(model);
	}

	public BocloudResult createSnapshot(FileSnapshotModel model, String vendor) {
		FileSystemProvider provider = getProvider(vendor, FileSystemProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.createSnapshot(model);
	}

	public BocloudResult removeSnapshot(FileSnapshotModel model, String vendor) {
		FileSystemProvider provider = getProvider(vendor, FileSystemProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.removeSnapshot(model);
	}

	public BocloudResult modifySnapshot(FileSnapshotModel model, String vendor) {
		FileSystemProvider provider = getProvider(vendor, FileSystemProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.modifySnapshot(model);
	}

}
