package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.VolumeModel;
import com.bocloud.cmp.model.storage.StorageFlashCopyModel;
import com.bocloud.cmp.provider.storage.FlashCopyProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class FlashCopyDriver extends GenericDriver<FlashCopyProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        FlashCopyProvider provider = getProvider(vendor, FlashCopyProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult listTargetVolume(String vendor, VolumeModel sourceVolume) {
        FlashCopyProvider provider = getProvider(vendor, FlashCopyProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.listTargetVolume(sourceVolume);
    }

    public BocloudResult create(String vendor, StorageFlashCopyModel storageFlashCopyModel) {
        FlashCopyProvider provider = getProvider(vendor, FlashCopyProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(storageFlashCopyModel);
    }

    public BocloudResult start(String vendor, StorageFlashCopyModel storageFlashCopyModel) {
        FlashCopyProvider provider = getProvider(vendor, FlashCopyProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.start(storageFlashCopyModel);
    }

    public BocloudResult stop(String vendor, StorageFlashCopyModel storageFlashCopyModel) {
        FlashCopyProvider provider = getProvider(vendor, FlashCopyProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.stop(storageFlashCopyModel);
    }

    public BocloudResult remove(String vendor, StorageFlashCopyModel storageFlashCopyModel) {
        FlashCopyProvider provider = getProvider(vendor, FlashCopyProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(storageFlashCopyModel);
    }

    public BocloudResult detail(String vendor, StorageFlashCopyModel storageFlashCopyModel) {
        FlashCopyProvider provider = getProvider(vendor, FlashCopyProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(storageFlashCopyModel);
    }

}
