package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.storage.StorageGroupModel;
import com.bocloud.cmp.model.storage.StorageHostModel;
import com.bocloud.cmp.provider.storage.HostProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 存储主机
 */
@Service("storageHostDriver")
public class HostDriver extends GenericDriver<HostProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor, String storageHostName) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list(storageHostName);
    }

    public BocloudResult create(String vendor, StorageHostModel model) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult rename(String vendor, StorageHostModel model) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.rename(model);
    }

    public BocloudResult remove(String vendor, StorageHostModel model) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(model);
    }

    public BocloudResult modify(String vendor, StorageHostModel model) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult appendPort(String vendor, StorageHostModel model) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.appendPort(model);
    }

    public BocloudResult removePort(String vendor, StorageHostModel model) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.removePort(model);
    }

    public BocloudResult attachVolume(String vendor, StorageHostModel model) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.attachVolume(model);
    }

    public BocloudResult detachVolume(String vendor, StorageHostModel model) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detachVolume(model);
    }

    public BocloudResult addGroups(String vendor, List<StorageGroupModel> model) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.addGroups(model);
    }

    public BocloudResult removeGroups(String vendor, List<StorageGroupModel> model) {
        HostProvider provider = getProvider(vendor, HostProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.removeGroups(model);
    }
}
