package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.HostModel;
import com.bocloud.cmp.model.VolumeModel;
import com.bocloud.cmp.model.storage.StorageIScsiPortModel;
import com.bocloud.cmp.provider.storage.IScsiPortProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class IScsiPortDriver extends GenericDriver<IScsiPortProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        IScsiPortProvider provider = getProvider(vendor, IScsiPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult create(String vendor, StorageIScsiPortModel model) {
        IScsiPortProvider provider = getProvider(vendor, IScsiPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult remove(String vendor, StorageIScsiPortModel model) {
        IScsiPortProvider provider = getProvider(vendor, IScsiPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(model);
    }

    public BocloudResult setACL(String vendor, StorageIScsiPortModel model, boolean acl) {
        IScsiPortProvider provider = getProvider(vendor, IScsiPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.setACL(model, acl);
    }

    public BocloudResult addGateway(String vendor, StorageIScsiPortModel model, HostModel gateway) {
        IScsiPortProvider provider = getProvider(vendor, IScsiPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.addGateway(model, gateway);
    }

    public BocloudResult removeGateway(String vendor, StorageIScsiPortModel model, HostModel gateway) {
        IScsiPortProvider provider = getProvider(vendor, IScsiPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.removeGateway(model, gateway);
    }

    public BocloudResult addVolume(String vendor, StorageIScsiPortModel model, VolumeModel volume){
        IScsiPortProvider provider = getProvider(vendor, IScsiPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.addVolume(model, volume);
    }

    public BocloudResult removeVolume(String vendor, StorageIScsiPortModel model, VolumeModel volume){
        IScsiPortProvider provider = getProvider(vendor, IScsiPortProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.removeVolume(model, volume);
    }
}
