package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.storage.StorageMdiskModel;
import com.bocloud.cmp.provider.storage.MdiskProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class MdiskDriver extends GenericDriver<MdiskProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult listByStorage(String vendor, String storageUuid) {
        MdiskProvider provider = getProvider(vendor, MdiskProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.listByStorage(storageUuid);
    }

    public BocloudResult get(String vendor, String mdiskPath) {
        MdiskProvider provider = getProvider(vendor, MdiskProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.getByPath(mdiskPath);
    }

    public BocloudResult listByVolume(String vendor, String volumePath) {
        MdiskProvider provider = getProvider(vendor, MdiskProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.listByVolume(volumePath);
    }

    public BocloudResult create(String vendor, StorageMdiskModel mdiskModel) {
        MdiskProvider provider = getProvider(vendor, MdiskProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(mdiskModel);
    }
}
