package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.storage.ObjectProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("objectDriver")
public class ObjectDriver extends GenericDriver<ObjectProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult exists(String bucket, String object, String vendor, String region) {
        ObjectProvider provider = getProvider(vendor, ObjectProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.exists(bucket, object);
    }


    public BocloudResult remove(String bucket, String object, String vendor, String region) {
        ObjectProvider provider = getProvider(vendor, ObjectProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(bucket, object);
    }


    public BocloudResult detail(String bucket, String object, String vendor, String region) {
        ObjectProvider provider = getProvider(vendor, ObjectProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(bucket, object);
    }


    public BocloudResult list(String bucket, String vendor, String region) {
        ObjectProvider provider = getProvider(vendor, ObjectProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list(bucket);
    }
}
