package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.VolumeGroupSnapModel;
import com.bocloud.cmp.provider.storage.VolumeGroupSnapProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("snapshotGroupDriver")
public class SnapshotGroupDriver extends GenericDriver<VolumeGroupSnapProvider> {
    @Autowired
    private ProviderRepository repository;


    public BocloudResult create(String vendor, VolumeGroupSnapModel model) {
        VolumeGroupSnapProvider provider = getProvider(vendor, VolumeGroupSnapProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(String vendor, VolumeGroupSnapModel model) {
        VolumeGroupSnapProvider provider = getProvider(vendor, VolumeGroupSnapProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult remove(String vendor, String snapGroupId) {
        VolumeGroupSnapProvider provider = getProvider(vendor, VolumeGroupSnapProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(snapGroupId);
    }

}
