package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.HostModel;
import com.bocloud.cmp.provider.storage.StorageGatewayProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 存储网关服务器接口实现类
 */
@Service("storageGatewayDriver")
public class StorageGatewayDriver extends GenericDriver<StorageGatewayProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult add(String vendor, HostModel model) {
        StorageGatewayProvider provider = getProvider(vendor, StorageGatewayProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.add(model);
    }

    public BocloudResult remove(String vendor, HostModel model) {
        StorageGatewayProvider provider = getProvider(vendor, StorageGatewayProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(model);
    }

    public BocloudResult sync(String vendor, List<HostModel> models) {
        StorageGatewayProvider provider = getProvider(vendor, StorageGatewayProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.sync(models);
    }


}
