package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.ImageModel;
import com.bocloud.cmp.model.SnapshotModel;
import com.bocloud.cmp.model.VolumeMetadataModel;
import com.bocloud.cmp.model.VolumeModel;
import com.bocloud.cmp.model.storage.StorageViewModel;
import com.bocloud.cmp.provider.storage.StorageViewProvider;
import com.bocloud.cmp.provider.storage.VolumeProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("storageViewDriver")
public class StorageViewDriver extends GenericDriver<StorageViewProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor, String region) {
        StorageViewProvider provider = getProvider(vendor, StorageViewProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list();
    }


    public BocloudResult create(String vendor, String region, StorageViewModel storageViewModel) {
        StorageViewProvider provider = getProvider(vendor, StorageViewProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(storageViewModel);
    }


    public BocloudResult remove(StorageViewModel storageViewModel, String vendor, String region) {
        StorageViewProvider provider = getProvider(vendor, StorageViewProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(storageViewModel);
    }
}
