package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.StorageViewGroupModel;
import com.bocloud.cmp.provider.storage.StorageViewGroupProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("storageViewGroupDriver")
public class StorageViewGroupDriver extends GenericDriver<StorageViewGroupProvider> {
    @Autowired
    private ProviderRepository repository;


    public BocloudResult addView(String vendor, StorageViewGroupModel model) {
        StorageViewGroupProvider provider = getProvider(vendor, StorageViewGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult removeView(String vendor, String viewUuid) {
        StorageViewGroupProvider provider = getProvider(vendor, StorageViewGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(viewUuid);
    }

    public BocloudResult attachVolume(String vendor, StorageViewGroupModel model) {
        StorageViewGroupProvider provider = getProvider(vendor, StorageViewGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.attachVolume(model);
    }

    public BocloudResult detachVolume(String vendor, StorageViewGroupModel model) {
        StorageViewGroupProvider provider = getProvider(vendor, StorageViewGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detachVolume(model);
    }

    public BocloudResult modifyClientGroup(String vendor, StorageViewGroupModel model) {
        StorageViewGroupProvider provider = getProvider(vendor, StorageViewGroupProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modifyClientGroup(model);
    }

}
