package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.StorageVolumeModel;
import com.bocloud.cmp.provider.storage.StorageVolumeProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("storageVolumeDriver")
public class StorageVolumeDriver extends GenericDriver<StorageVolumeProvider> {
	@Autowired
	private ProviderRepository repository;

	public BocloudResult list(String vendor) {
		StorageVolumeProvider provider = getProvider(vendor, StorageVolumeProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.list();
	}

	public BocloudResult create(String vendor, StorageVolumeModel model) {
		StorageVolumeProvider provider = getProvider(vendor, StorageVolumeProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.create(model);
	}

	public BocloudResult remove(StorageVolumeModel model, String vendor) {
		StorageVolumeProvider provider = getProvider(vendor, StorageVolumeProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.remove(model);
	}

	public BocloudResult detail(StorageVolumeModel model, String vendor) {
		StorageVolumeProvider provider = getProvider(vendor, StorageVolumeProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.detail(model);
	}

	public BocloudResult modify(String vendor, StorageVolumeModel model) {
		StorageVolumeProvider provider = getProvider(vendor, StorageVolumeProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.modify(model);
	}

	public BocloudResult attach(String vendor, StorageVolumeModel model) {
		StorageVolumeProvider provider = getProvider(vendor, StorageVolumeProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.attach(model);
	}

	public BocloudResult detach(String vendor, StorageVolumeModel model) {
		StorageVolumeProvider provider = getProvider(vendor, StorageVolumeProvider.class, repository);
		if (before(provider).isFailed()) {
			return BocloudResult.FAILED("平台认证失败！");
		}
		return provider.detach(model);
	}
}
