package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.network.SwitchProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Scp查询交换机接口实现类
 *
 * @author weiwei
 */
@Service("switcherDriver")
public class SwitcherDriver extends GenericDriver<SwitchProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        SwitchProvider provider = getProvider(vendor, SwitchProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list();
    }
}
