package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.StorageSyncedSetModel;
import com.bocloud.cmp.provider.storage.SyncedSetProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("syncedSetDriver")
public class SyncedSetDriver extends GenericDriver<SyncedSetProvider> {
    @Autowired
    private ProviderRepository repository;

    public BocloudResult listByStorage(String vendor, String storageUuid) {
        SyncedSetProvider provider = getProvider(vendor, SyncedSetProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.listByStorage(storageUuid);
    }

    public BocloudResult create(String vendor, StorageSyncedSetModel model) {
        SyncedSetProvider provider = getProvider(vendor, SyncedSetProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(model);
    }

    public BocloudResult modify(String vendor, StorageSyncedSetModel model) {
        SyncedSetProvider provider = getProvider(vendor, SyncedSetProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modify(model);
    }

    public BocloudResult remove(String vendor, StorageSyncedSetModel model) {
        SyncedSetProvider provider = getProvider(vendor, SyncedSetProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(model);
    }

    public BocloudResult addVolume(String vendor, StorageSyncedSetModel model) {
        SyncedSetProvider provider = getProvider(vendor, SyncedSetProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.addVolume(model);
    }

    public BocloudResult removeVolume(String vendor, StorageSyncedSetModel model) {
        SyncedSetProvider provider = getProvider(vendor, SyncedSetProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.removeVolume(model);
    }

    public BocloudResult start(String vendor, StorageSyncedSetModel model) {
        SyncedSetProvider provider = getProvider(vendor, SyncedSetProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.start(model);
    }

    public BocloudResult stop(String vendor, StorageSyncedSetModel model) {
        SyncedSetProvider provider = getProvider(vendor, SyncedSetProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.stop(model);
    }

    public BocloudResult detail(String vendor, StorageSyncedSetModel model) {
        SyncedSetProvider provider = getProvider(vendor, SyncedSetProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(model);
    }
}
