package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.SnapshotModel;
import com.bocloud.cmp.provider.storage.VolumeSnapProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("volumeSnapDriver")
public class VolumeSnapDriver extends GenericDriver<VolumeSnapProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor, String region) {
        VolumeSnapProvider provider = getProvider(vendor, VolumeSnapProvider.class, repository);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败!");
        }
        return provider.list();
    }

    public BocloudResult create(String vendor, String region, SnapshotModel model) {
        VolumeSnapProvider provider = getProvider(vendor, VolumeSnapProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败!");
        }
        return provider.create(model);
    }

    public BocloudResult modify(String vendor, String region, SnapshotModel model) {
        VolumeSnapProvider provider = getProvider(vendor, VolumeSnapProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败!");
        }
        return provider.modify(model);
    }

    public BocloudResult remove(String vendor, String region, SnapshotModel model) {
        VolumeSnapProvider provider = getProvider(vendor, VolumeSnapProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败!");
        }
        return provider.remove(model);
    }

    public BocloudResult detail(String vendor, String region, SnapshotModel model) {
        VolumeSnapProvider provider = getProvider(vendor, VolumeSnapProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败!");
        }
        return provider.detail(model);
    }

    public BocloudResult revert(String vendor, String region, SnapshotModel model) {
        VolumeSnapProvider provider = getProvider(vendor, VolumeSnapProvider.class, repository, region);
        if (before(provider).isFailed()) {
            return new BocloudResult(false, "平台认证失败!");
        }
        return provider.revert(model);
    }
}
