package com.bocloud.cmp.driver.storage;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.model.VolumeTemplateModel;
import com.bocloud.cmp.provider.storage.VolumeTemplateProvider;
import com.bocloud.common.model.BocloudResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 存储卷模板
 * @author luyanchao
 * @since 2019/1/25 10:44
 */
@Service("volumeTempletaDriver")
public class VolumeTemplateDriver extends GenericDriver<VolumeTemplateProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult list(String vendor) {
        VolumeTemplateProvider provider = getProvider(vendor, VolumeTemplateProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.list();
    }

    public BocloudResult create(String vendor, VolumeTemplateModel template) {
        VolumeTemplateProvider provider = getProvider(vendor, VolumeTemplateProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.create(template);
    }

    public BocloudResult modify(String vendor, VolumeTemplateModel template) {
        VolumeTemplateProvider provider = getProvider(vendor, VolumeTemplateProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.modify(template);
    }

    public BocloudResult remove(String templateId, String vendor) {
        VolumeTemplateProvider provider = getProvider(vendor, VolumeTemplateProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.remove(templateId);
    }

    public BocloudResult detail(String templateId, String vendor) {
        VolumeTemplateProvider provider = getProvider(vendor, VolumeTemplateProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.detail(templateId);
    }
}
