package com.bocloud.cmp.driver.utils;

import com.bocloud.cmp.entity.enums.CloudProvider;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 云供应商转换器
 * 
 * @author dmw
 *
 */
public class VendorConverter {
	private static Logger logger = LoggerFactory.getLogger(VendorConverter.class);

	/**
	 * 云供应商类型转换器，报异常的时候返回未知
	 * 
	 * @return
	 */
	public static CloudProvider convert(String category) {
		try {
			return CloudProvider.valueOf(category.trim().toUpperCase());
		} catch (Exception e) {
			logger.error("", e);
			return CloudProvider.UNKNOWN;
		}
	}
}
