package com.bocloud.cmp.driver.veeam;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.veeam.mgr.MGRRestorePointProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.veeam.TaskModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("mGRRestorePointDriver")
public class MGRRestorePointDriver extends GenericDriver<MGRRestorePointProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<TaskModel> restore(String vendor, String id, Boolean powerOnAfterRestore, Boolean keepOriginalVm) {
        MGRRestorePointProvider provider = getProvider(vendor, MGRRestorePointProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.restore(id, powerOnAfterRestore, keepOriginalVm);
    }
}
