package com.bocloud.cmp.driver.veeam;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.veeam.br.BackupProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.veeam.BackupModel;
import com.bocloud.nms.model.veeam.BackupObjectModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("veeamBackupDriver")
public class VeeamBackupDriver extends GenericDriver<BackupProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<BackupModel> getByUuid(String vendor, String id) {
        BackupProvider provider = getProvider(vendor, BackupProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.getByUuid(id);
    }

    public BocloudResult<List<BackupObjectModel>> getBackupObjects(String vendor, String id) {
        BackupProvider provider = getProvider(vendor, BackupProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.getBackupObjects(id);
    }
}
