package com.bocloud.cmp.driver.veeam;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.veeam.br.BackupObjectProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.veeam.ObjectRestorePointModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service("veeamBackupObjectDriver")
public class VeeamBackupObjectDriver extends GenericDriver<BackupObjectProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<List<ObjectRestorePointModel>> listBackupsObject(String vendor, String id) {
        BackupObjectProvider provider = getProvider(vendor, BackupObjectProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.listBackupsObject(id);
    }

}
