package com.bocloud.cmp.driver.veeam;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.veeam.mgr.RestoreSessionProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.veeam.RestoreSessionModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("veeamRestoreSessionDriver")
public class VeeamRestoreSessionDriver extends GenericDriver<RestoreSessionProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<RestoreSessionModel> getRestoreSession(String vendor, String id) {
        RestoreSessionProvider provider = getProvider(vendor, RestoreSessionProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.getRestoreSession(id);
    }
}
