package com.bocloud.cmp.driver.veeam;

import com.bocloud.cmp.driver.GenericDriver;
import com.bocloud.cmp.driver.ProviderRepository;
import com.bocloud.cmp.provider.veeam.br.SessionProvider;
import com.bocloud.common.model.BocloudResult;
import com.bocloud.nms.model.veeam.SessionModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("veeamSessionDriver")
public class VeeamSessionDriver extends GenericDriver<SessionProvider> {

    @Autowired
    private ProviderRepository repository;

    public BocloudResult<SessionModel> getJobSession(String vendor, String id) {
        SessionProvider provider = getProvider(vendor, SessionProvider.class, repository);
        if (before(provider).isFailed()) {
            return BocloudResult.FAILED("平台认证失败！");
        }
        return provider.getJobSession(id);
    }

}
